﻿-------------------------------------------------------------------------------
-- [ Texte - Localisation - Boutons d'aide] --
-------------------------------------------------------------------------------

CHARACTERENBR = " charactères sont disponibles pour cet attribut.\n{o}Attention : un charactère accentué en vaut deux.";
CHRACTEREINTERDIT = "{r}Les charactères spéciaux sont interdits.\n^ $ ( ) % . [ ] * + - ? | {w}";
MUSTSAISIR = "{o}Vous devez précisez une valeur pour cet attribut.{w}";
NOMUSTSAISIR = "{v}Cet attribut est facultatif.{w}"
CAREFULL = "\n\n|cffffaa00Cette action ne peut être annulée.\n\nVoulez-vous vraiment effectuer cette action ?";
TRP_ENTETE = "|TInterface\\AddOns\\totalRP\\Images\\TRPlogo.tga:75:125|t\n";
CHATFRAMEEXPLICATION = "Fenêtre de discussion : \n1 - Général\n2 - Journal de Combat\n3 à 7 - Fenêtres supplémentaires"

TEXTE_AIDE_BUTTON = {
	-- Création d'objets
	CreaObjReference = {
		Nom = "Référence de l'objet";
		Texte = "La référence d'un objet est la clé (appelé aussi ID) qui permet à TotalRP de différencier cet objet d'un autre.\n"
			  .."Lorsque vous échangez un objet avec quelqu'un d'autre, il garde sa référence.\nLa référence est un nombre à 16 chiffres automatiquement généré à la création de l'objet.\n"
			  .."\n{o}Elle vous est indiquée à titre informatif, pour la copier/coller pour les commandes TRP par exemple, mais vous ne pouvez la modifier.";
	},
	CreaObjNom = {
		Nom = "Nom de l'objet";
		Texte = "C'est le nom que portera l'objet.\n\n{o}Remarque : Deux objets différents peuvent porter le même nom."..MUSTSAISIR.."\n\n50"..CHARACTERENBR.."\n\n"..CHRACTEREINTERDIT;
	},
	CreaObjButinOnly = {
		Nom = "Ajout Manuel Interdit";
		Texte = "Cette option vous permet d'empêcher quelqu'un possédant la référence de cet objet de l'ajouter lui-même dans son inventaire à volonté. Seul vous, auteur, pourrez le faire."..
		"\n\nVous pourrez ainsi contrôler à coup sûr la quantité d'unités de cet objet sur votre royaume.";
	},
	CreaObjIcone = {
		Nom = "Icône de l'objet";
		Texte = "C'est l'icône qui sera attribuée à l'objet dans l'inventaire.\n\nLorsque vous cliquerez sur le bouton, une fenêtre vous invitera à choisir une icône parmis celle "
				.."du jeu. Vous pouvez affiner la recherche.";
	},
	CreaObjModele = {
		Nom = "Modèle 3D de l'objet";
		Texte = "Vous pouvez associer un modèle 3D à votre objet. Ce modèle sera visible lors du passage de la souris sur l'icone de l'objet."..
				" La liste s'étoffera de version en version.\n\n"..NOMUSTSAISIR;
	},
	CreaObjDescri = {
		Nom = "Description de l'objet";
		Texte = "C'est la description que portera votre objet dans la fenêtre d'informations (tooltip) de cet objet.\n\n"..NOMUSTSAISIR.."\n\n200"..CHARACTERENBR;
	},
	CreaObjPoids = {
		Nom = "Poids de l'objet";
		Texte = "Détermine le poids, en gramme, d'une unité de cet objet. \n\nCe poids permet de calculer la masse totale que porte un personnage et cela influencera, dans une"
				.." prochaine version de TotalRP, sur la vitesse de ses déplacements et sa fatigue ainsi que sur la probabilité que le sac cède.\n\n"
				.."{o}Le poids peut être nul (0) et de maximum 10 tonnes.";
	},
	CreaObjUnique = {
		Nom = "Objet Unique";
		Texte = "Détermine si l'objet ne peut être possédé qu'en une quantité limitée.\n\n"..NOMUSTSAISIR.."\n\n"
				.."Si l'objet est unique, vous devez indiquer combient d'unités maximum un personnage peut en emporter à la fois, tout sac confondus.\n\n"
				.."{v}Si non, laissez le à 0 (infini).\nIl peut être de maximum 999.";
	},
	CreaObjCategorie = {
		Nom = "Catégorie de l'objet";
		Texte = "La catégorie et la sous-catégorie de l'objet s'afficheront dans la fenêtre d'informations (tooltip) de l'objet. La catégorie permet de trier plus facilement les objets dans votre inventaire.\n\n{o}La catégorie est obligatoire, par contre "
				.."la sous-catégorie est facultative (sélectionnez \"Aucune\" pour ne pas en avoir).";
	},
	CreaObjUtilisable = {
		Nom = "Objet Utilisable";
		Texte = "Détermine si l'objet peut être utilisé.\n\nActiver cette option déverouille les options associées ainsi que le panneau \"Util. : Conditions\".";
	},
	CreaObjLock = {
		Nom = "Verouillage";
		Texte = "Si vous verouillez l'objet, seul vous, créateur, pourrez l'éditer.\n\nCela peut-être utile si vous utilisez des balises de texte dans certains attribut. De "
				.."cette manière les curieux ne pourront tricher en allant consulter les informations de l'objet en l'éditant.\n\n{o}Soyez cependant conscient que verouiller un objet est anti-éducatif et empêche les autres de corriger votre objet si il contient des erreurs.";
	},
	CreaObjCharges = {
		Nom = "Charges";
		Texte = "Les charges représentent le nombre de fois qu'un objet peut être utilisé {o}avant d'être automatiquement détruit{w}.\n\n{v}0 signifie infini !\n\n"
				..MUSTSAISIR.."\n\nVous êtes limité à 999 charges maximum.";
	},
	CreaObjOnUseMessage = {
		Nom = "A l'utilisation : Message";
		Texte = "Ce message s'affichera dans la fenêtre de chat lors de l'utilisation de l'objet. {o}Seul le joueur utilisant l'objet vera ce message, il n'est pas partagé.\n\n"
				..NOMUSTSAISIR.."\n\n200 "..CHARACTERENBR;
	},
	CreaObjOnUseEmote = {
		Nom = "A l'utilisation : Emote";
		Texte = "Cette émote sera effectuée par le personnage à l'utilisation de l'objet. C'est une émote de type /e , vous ne devez pas marquer /e pour autant.\n\n"
				.."Exemple : \nAttribut : 'est confus'\nAffichage : 'Machin est confus'\n\n"
				..NOMUSTSAISIR.."\n\n100 "..CHARACTERENBR;
	},
	CreaObjOnDeathMessage = {
		Nom = "A la suppresion : Message";
		Texte = "Ce message s'affichera dans la fenêtre de chat lors de la suppression de l'objet (Lorsque ses charges arrivent à 0). {o}Seul le joueur utilisant l'objet vera ce message, il n'est pas partagé.\n\n"
				.."{o}Ce message s'affichera en addition de celui à l'utilisation.\n\n"
				..NOMUSTSAISIR.."\n\n200 "..CHARACTERENBR;
	},
	CreaObjOnDeathEmote = {
		Nom = "A la suppresion : Emote";
		Texte = "Cette émote sera effectuée par le personnage à la suppression de l'objet (Lorsque ses charges arrivent à 0). C'est une émote de type /e , vous ne devez pas marquer /e pour autant.\n\n"
				.."Exemple : \nAttribut : 'est confus'\nAffichage : 'Machin est confus'\n\n"
				.."{o}Cette émote s'effectuera en addition de celle à l'utilisation.\n\n"
				..NOMUSTSAISIR.."\n\n100 "..CHARACTERENBR;
	},
	CreaObjOnUseCreate = {
		Nom = "A l'utilisation : Créer";
		Texte = "Lors de l'utilisation de l'objet, le personnage recevra un certain nombre d'unités de l'objet choisi en attribut.\n\n"..NOMUSTSAISIR.."\n\n{v}Cliquez-gauche sur le bouton pour faire apparaitre "
				.."la fenêtre de sélection d'objet. Cette fenêtre comprend les objets crées qui ne sont pas verouillés ainsi que les objets pré-construit de TotalRP.\nCliquez-droit sur le bouton pour choisir le nombre d'unités qui sera donné.";
	},
	CreaObjOnDeathCreate = {
		Nom = "A la suppression : Créer";
		Texte = "Lors de la suppression de l'objet (Lorsque ses charges arrivent à 0), le personnage recevra un certain nombre d'unités de l'objet choisi en attribut.\n\n"..NOMUSTSAISIR
				.."\n\n{o}Cet objet sera reçu en addition de celui à l'utilisation.\n\n{v}Cliquez-gauche sur le bouton pour faire apparaitre "
				.."la fenêtre de sélection d'objet. Cette fenêtre comprend les objets crées qui ne sont pas verouillés ainsi que les objets pré-construit de TotalRP.\nCliquez-droit sur le bouton pour choisir le nombre d'unités qui sera donné.";
	},
	CreaObjOnUseSound = {
		Nom = "A l'utilisation : Son";
		Texte = "Lors de l'utilisation de l'objet, le son sera joué. Seul le joueur entendra le son, il n'est pas partagé.\n\n"..NOMUSTSAISIR.."\n\n{v}Cliquez sur le bouton Liste pour faire apparaitre "
				.."la fenêtre de sélection de sons. Cette liste n'est pas exhaustive mais reprend les principaux sons du jeu. Cette liste grandira au fil des versions.";
	},
	CreaObjOnDeathSound = {
		Nom = "A la suppression : Son";
		Texte = "Lors de la suppression de l'objet (Lorsque ses charges arrivent à 0), le son sera joué. Seul le joueur entendra le son, il n'est pas partagé.\n\n"
				.."{o}Attention, ce son remplacera le son à l'utilisation.\n\n"
				..NOMUSTSAISIR.."\n\n{v}Cliquez sur le bouton Liste pour faire apparaitre "
				.."la fenêtre de sélection de sons. Cette liste n'est pas exhaustive mais reprend les principaux sons du jeu. Cette liste grandira au fil des versions.";
	},
	CreaObjTooltipUse = {
		Nom = "Phrase d'utilisation";
		Texte = "Cette phrase s'ajoutera dans le tooltip derrière le mot \"{v}Utilisation : {w}\". Par convention, commencez par un verbe.\n\nExemple pour une carte :\n"
				.."Attribut : 'consulter la carte'\nAffichage : '{v}Utiliser : Consulter la carte{w}'\n\n"..NOMUSTSAISIR.."\n\n50 "..CHARACTERENBR;
	},
	CreaObjLierDocu = {
		Nom = "Lier au document";
		Texte = "Vous permet de lier l'objet au document. L'utilisation de l'objet ouvrira le document.\n\n"..NOMUSTSAISIR.."\n\n{v}Cliquez sur le bouton pour faire apparaitre "
				.."la fenêtre de sélection des documents. Cette fenêtre comprend les documents qui ne sont pas verouillés par leur créateur.";
	},
	CreaObjCooldown = {
		Nom = "Temps de rechargement";
		Texte = "Vous permet d'imposer un temps d'attente, en secondes, entre deux utilisations de l'objet.\n\n"..NOMUSTSAISIR.."\n\nLes temps d'utilisation sont sauvegardés, même lorsque le jeu est quitté.";
	},
	CreaObjConditions = {
		Nom = "Conditions d'utilisation";
		Texte = "Vous permet d'utiliser les options de conditions d'utilisation.\n\n"..NOMUSTSAISIR;
	},
	CreaObjCiblage = {
		Nom = "Cible obligatoire";
		Texte = "Détermine si l'utilisateur doit cibler un personnage (lui-même ou une autre personne) afin de pouvoir utiliser l'objet.\n\n{r}Si il ne le fait pas, un message \"Vous n'avez pas de cible\" sera affiché.\n\n"..NOMUSTSAISIR;
	},
	CreaObjCiblageCondSupp = {
		Nom = "Conditions sur la cible";
		Texte = "Vous permet d'effectuer une série de tests sur {o}la cible de l'utilisateur de l'objet{w}. L'objet ne sera utilisé que si tout les tests réussissent.\n\n{r}Si non, un message \"Cible incorrecte\" sera affiché.\n\n"..NOMUSTSAISIR.."\n\n"
				.."{o}Pour plus d'information sur la syntaxe des tests, merci de visiter le forum de Total RP :\n{c}http://forums.telkostrasz.be/index.php\n{o}Section \"Tutoriel\", discussion \"[Tutoriel 1.103] Les Tests\".";
	},
	CreaObjUserCondSupp = {
		Nom = "Conditions sur l'utilisateur";
		Texte = "Vous permet d'effectuer une série de tests sur {o}l'utilisateur de l'objet{w}. L'objet ne sera utilisé que si tout les tests réussissent.\n\n{r}Si non, un message \"Vous ne pouvez pas utiliser cet objet\" sera affiché.\n\n"..NOMUSTSAISIR.."\n\n"
				.."{o}Pour plus d'information sur la syntaxe des tests, merci de visiter le forum de Total RP :\n{c}http://forums.telkostrasz.be/index.php\n{o}Section \"Tutoriel\", discussion \"[Tutoriel 1.103] Les Tests\".";
	},
	CreaObjInventaire = {
		Nom = "Composant(s) nécessaire(s)";
		Texte = "Vous permet d'ajouter des composants nécessaires à l'utilisation de l'objet.\n\n{r}Si l'utilisateur ne possède pas un des composants requis, un message \"Composant manquant : [Nom du composant]\" sera affiché.\n\n"..NOMUSTSAISIR.."\n\n"
				.."{o}Pour plus d'information sur la syntaxe des composants, merci de visiter le forum de Total RP :\n{c}http://forums.telkostrasz.be/index.php\n{o}Section \"Tutoriel\", discussion \"[Tutoriel 1.103] Les composants d'utilisation\".";
	},
	-- Création de documents
	CreaDocuVignetteTitre = {
		Nom = "Titre du document";
		Texte = "C'est le titre du document.\n\n"..MUSTSAISIR.."\n\n50 "..CHARACTERENBR;
	},
	CreaDocuVignetteDate = {
		Nom = "Date du document";
		Texte = "C'est la date à laquelle le document a été rédigé. {o}Cela ne doit pas obligatoirement correspondre à la date où le document a été crée ! {v}C'est bien la date RP de la rédaction du document qu'il faut renseigner.\n\n"..NOMUSTSAISIR.."\n\n50 "..CHARACTERENBR;
	},
	CreaDocuVignetteAuteur = {
		Nom = "Auteur du document";
		Texte = "C'est l'auteur du document. {o}Cela ne doit pas obligatoirement être votre personnage ! {v}C'est bien l'auteur RP du document qu'il faut renseigner.\n\n"..NOMUSTSAISIR.."\n\n50 "..CHARACTERENBR;
	},
	CreaDocuVignetteIcone = {
		Nom = "Icone du document";
		Texte = "C'est l'icône qui sera attribuée au document dans la liste des documents.\n\nLorsque vous cliquerez sur la saisie, une fenêtre vous invitera à choisir une icône parmis celles "
				.."du jeu.";
	},
	CreaDocuLier = {
		Nom = "Lié à un objet";
		Texte = "Si vous lier ce document à un objet et que vous activer cet attribut, le document ne pourra être consulté qu'en utilisant l'objet.\n\n"..NOMUSTSAISIR;
	},
	CreaDocuLock = {
		Nom = "Verouiller";
		Texte = "Si vous verouillez le document, seul vous, créateur, pourrez l'éditer.\n\nCela peut-être utile si vous utilisez des balises de texte dans certains attribut. De "
				.."cette manière les curieux ne pourront tricher en allant consulter les informations du document en l'éditant.\n\n{o}Soyez cependant conscient que verouiller un document est anti-éducatif.";
	},
};

TRP_TEXT_STATIC_POPUP = {
	TRP_REG_EPURER_LISTE = "Cette action supprimera du Registre tout les personnage de ce Royaume "
							.."que vous n'avez jamais croisés avec l'un de vos personnages.";
	TRP_REG_DELETE_PERSO = "Cette action supprimera ce personnage du Registre. Vous conserverez néanmoins les notes que vous lui "
							.."avez attribuées ainsi que la relation entre vos personnages et lui.";
	TRP_AVERT_USE_CHAT = "Vous venez de désactiver la fonction d'amélioration de chat. Vos fenêtre se comporteront donc normalement.\n\n{o}Seulement, si vous"
	.." avez désactivé cette option pour cause de conflits avec d'autres add-ons, nous vous conseillons de redémarrer votre interface pour éliminer tout lien entre TRP et les fenêtres de chat.\n\n{v}Redémarrer l'interface ?";
}

TRPCheckOptionTooltip = {
	USEPERSOTOOL = " Permet d'utiliser un tooltip (infobulle) personnalisé lorsque vous pointez un joueur. Ce nouveau tooltip contient des informations propres à TotalRP "
					.."et vous pouvez vous-même choisir son contenu via les options ci-dessous.";
	COMMUPARENT = " Permet d'automatiquement englober vos phrases de parenthèses lorsque vous parlez en étant en statut HRP sur les canaux /dire, /groupe, /guilde, /w et /crier.";
	RACCALPHA = " Détermine la transparence de la barre de raccourcis.";
	RACCREINIT = " Réinitialise la position par défaut de la barre de raccourcis, au cas où vous l'auriez perdue. ;)";
	TOOLSTATUT = " Affiche le statut rôle-play (RP ou HRP) du personnage pointé juste après son nom complet dans le tooltip.";
	RACCLOCK = " Verouille la barre de raccourcis, vous empêchant de la déplacer par erreur.";
	TOOLST = " Affiche le sous-titre du personnage pointé en dessous du nom complet dans le tooltip.";
	TOOLACTUELLE = " Affiche la description \"actuelle\" du personnage pointé dans le tooltip.";
	TOOLDESCRI = " Affiche le début de la description physique (les 200 premiers caractères) du personnage pointé dans le tooltip.";
	TOOLRELATION = " Affiche la relation que le personnage pointé a avec votre personnage sous forme d'une icône.";
	TOOLALIGNEMENT = " Affiche l'alignement du personnage pointé dans le tooltip.";
	TOOLHUMEUR = " Affiche l'humeur du personnage pointé dans le tooltip.";
	TOOLGUILD = " Affiche les informations (Nom, Grade) de la guilde du personnage pointé dans le tooltip.";
	TOOLIMAGE = " Affiche la faction et le statut PvP du personnage pointé sous forme d'icône avant le nom complet dans le tooltip.";
	TOOLCOUPERNOM = " Si le nom complet du personnage pointé est trop grand et dépasse la limite que vous choisissez, il sera coupé.";
	TOOLCOUPERST = " Si le sous-titre du personnage pointé est trop grand et dépasse la limite que vous choisissez, il sera coupé.";
	TOOLINVAIDE = " Affiche la liste des interactions possibles avec les objets pointés dans le tooltip. (supprimer, donner, préparer un colis...etc)";
	TOOLINVDOCU = " Si un objet pointé est lié à un document, les informations vignettes du document seront affichés dans le tooltip.";
	CHECKRESUME = " A la sélection d'un personnage, affiche une fenêtre contenant un résumé des informations du personnage sélectionné. (Fenêtre dans le style de FlagRSP)";
	RESUMEPERSIS = " Si cette option est activée, la fenêtre de résumé ne se fermera pas automatiquement à la désélection du personnage. Il faudra la fermer manuellement.";
	RESUMEOPACITE = " Détermine la transparence de la fenêtre de résumé des personnages ciblés.";
	ALIGNEPUBLIC = " Détermine si l'Alignement de votre personnage (Moral et Ethique) sera visible aux yeux des autres joueurs.";
	ALIGNAFFICHE = " Détermine si vous pouvez voir l'Alignement (Moral et Ethique) des autres personnages.";
	NOTIFYAJOUT = " Lorsqu'un personnage sera ajouté à votre Registre, un message s'affichera pour vous l'indiquer.";
	COMPATFLAG = " Vous connecte au channel de FlagRSP et vous permet de récupérer les informations qui y circulent. Chaque personnage utilisant FlagRSP (ou bien TotalRP et ayant activé cette option) sera"
				.." automatiquement ajouté au Registre et ses informations RSP (Nom, Titre, Préfixe et Description) seront récupérées. Vos informations RSP seront aussi envoyées sur le channel, "
				.."permettant aux joueur utilisant FlagRSP (ou bien TotalRP et ayant activé cette option) de les récupérer.";
	FORCEMAJ = " Oblige TotalRP à tenter une mise à jour des informations d'un personnage lorsque vous consultez sa fiche.";
	RAPPELINFO = " Vous affiche un rappel des informations importantes de votre personnage (Statut RP, Description Actuelle..) à votre connexion.";
	DEBUG = " Affiche les messages de débugging. Utile pour les bêta-testeurs.";
	ICONPOS = " Détermine l'écartement de l'icône TotalRP de la minimap par rapport au centre de la minimap.";
	ICONROT = " Détermine la rotation de l'icône TotalRP autour de la minimap.";
	COMBATCLOSE = " Ferme automatiquement toute les fenêtres de TotalRP si votre personnage entre en combat.";
	NEWVERSION = " Vous affiche un message vous prévenant de la disponibilité d'une nouvelle version de TotalRP si quelqu'un possédant une version plus récente que la vôtre essaye d'interagir avec vous.";
	CHATAMELIO = " Permet à Total RP d'améliorer l'affichage des fenêtres de chat.";
	HRPDETECT = " Total RP détectera toute parole entre parenthèses et l'affichera dans une autre couleur (plus sombre) en plaçant un tag [HRP] devant.";
	EMOTEDETECT = " Total RP détectera toute parole entre étoiles (**) ou entre cônes (<>) et l'affichera comme si c'était une émote personnelle (/me).";
	SPAMDETECT = " Total RP détectera et n'affichera pas les messages contenant une combinaison de lettres que vous aurez marquée comme interdite.";
	NAMEINCHAT = " Affiche aussi le nom de famille dans la fenêtre de discussion.";
	DEBUGFRAME = " Si vous souhaitez afficher les messages debug dans une fenêtre de discussion spécifique.\n\n"..CHATFRAMEEXPLICATION;
	HRPDETECTFRAME = " Si vous souhaitez que les paroles HRP soient placées dans une autre fenêtre de discussion que celle où elles sont apparues, indiquez ici le numéro de la fenêtre de discussion cible. Sinon, laissez le champ vide.\n\n"..CHATFRAMEEXPLICATION;
	SPAMDETECTFRAME = " Si vous souhaitez que les messages de spam soient placées dans une autre fenêtre de discussion plutôt que de ne pas être affichés du tout, indiquez ici le numéro de la fenêtre de discussion cible.\n\n"..CHATFRAMEEXPLICATION;
	SPAMLISTEXPLAIN = " Entrez ici une suite de groupes de caractères qui sont généralement présent uniquement dans les messages de Spam. Tout message"
						.." contenant au moins un de ses groupes sera considéré comme du Spam et ne sera pas affiché (ou affiché ailleur selon vos options)."
						.." Séparez chaque groupe par un passage à la ligne ! Les caractères non-alphanumériques (. , ; : ! ? ..etc) DOIVENT être précédés de % ! Utilisez Escape pour quitter et enregistrer.";
	SPAMLISTEXPLAINB = " Si vous n'êtes pas à l'aise avec la notion de \"pattern\", ne vous aventurez pas dans l'édition de cette liste, vous risqueriez de créer des erreurs.";
	ACTIVATESOUND = " Permettre à TotalRP de jouer les sons. Les sons peuvent êtres déclenchés par l'utilisation d'un objet ou par l'utilisation de la liste de sons.";
	SONSATFLOOD = " Permet de limiter le flux sonore joué par TotalRP.\nUne fois activé, vous pouvez indiquer dans le cadre ci-contre le nombre de secondes devant"
				.." s'écouler entre deux sons. Cela vaut autant pour les sons reçu d'autres joueurs que ceux émis par l'utilisation d'objets.";
	SONSCOOLDOWN = " Indiquez le nombre de secondes devant s'écouler entre deux sons.";
	SONSLOG = " Vous permet de voir, dans une fenêtre de Chat, les différentes personnes vous envoyant des sons.\nVous pourrez ainsi facilement débusquer les floodeurs et les rendre muet.\n( ctrl + clic droit sur leur nom => Rendre Muet)";
	SONSLOGFRAME = " Indique dans quelle fenêtre de Chat se tiendra le journal.\n\n"..CHATFRAMEEXPLICATION;
	INVFRAME = "Indiquez ici la fenêtre de Chat dans laquelle vous voulez que les messages propres à l'utilisation d'objets s'affichent.\n\n"..CHATFRAMEEXPLICATION;
	NAMECOLOR = " Afficher les noms des personnages dans la couleur relative à leur relation.";
	BARREVIE = " Afficher la barre de vie du personnage pointé en dessous du tooltip.";
	ICONRELATION = " Affiche l'icône devant le nom du personnage qui parle, relative à la relation que vous lui avez assignée. La relation \"inconnue\" ne sera pas affichée.";
	LOREFRAMECHECK = " Vous permet de choisir dans quelle fenêtre de dialogue TRP placera les traductions reçues par l'add-on Lore.\n\n"..CHATFRAMEEXPLICATION.."\n\nAttention : Cela ne concerne que les traductions des autres personnages. Les traductions de vos propres phrases (via l'option \"Translate to self\" de Lore) seront placées dans la fenêtre Générale. C'est l'add-on Lore qui gère cela, je ne peux rien y faire. ;(";
}

CreaObjError = {
	TOOSMALLID = "{w}{r}Erreur : La référence de l'objet doit contenir 16 chiffres.";
	IFALREADYEXIST = "{w}{r}Erreur : Il existe déjà un objet possédant cette référence.\nObjet : ";
	NONAMEDETECTED = "{w}{r}Erreur : Vous n'avez pas donné de nom à l'objet.";
	ICONEFOIREUSE = "{w}{o}Avertissement : Le nom d'icône que vous avez entré est invalide. Si vous ne le corriger pas, l'icône par défaut \"?\" sera utilisée.";
	IDCHANGE = "{w}{o}Avertissement : Vous avez changé la référence de l'objet. Soyez conscient que tout autre objet faisant d'une manière ou d'une autre référence à celui-ci risque de ne plus fonctionner correctement. Si c'est le cas, vous pourrez les corriger";
	NOSTOCK = "{w}{r}Erreur : Vous n'avez pas défini le nombre d'unités empilables.";
	NOUNIQUE = "{w}{r}Erreur : Vous n'avez pas défini un nombre d'unités maximum pour l'objet.";
	NOCHARGE = "{w}{r}Erreur : Vous n'avez pas défini un nombre de charge(s) pour l'objet.";
	ONUSECREATREF = "{w}{r}Erreur : Créer objet à l'utilisation : Référence manquante ou incorrecte.";
	ONDEATHCREATREF = "{w}{r}Erreur : Créer objet à la suppression : Référence manquante ou incorrecte.";
	ONUSESOUND = "{o}Avertissement : La référence du son à l'utilisation est manquante.";
	ONDEATHSOUND = "{o}Avertissement : La référence du son à la suppression est manquante.";
}

ExchangeError = {
	NOTARGET = "Vous devez sélectionner un personnage à portée.";
	NORANGE = "La cible n'est pas à portée pour effectuer un échange.";
	REFUSAL = "{r}Echange refusé par ";
	CANTUNIQUE = " ne peut pas posséder d'avantage d'unités de cet objet.";
	CANTUNIQUESELF = "Vous ne pouvez pas posséder d'avantage d'unités de cet objet.";
	HASNOTREFPERSO = "{r}Ce joueur ne possède pas la référence de cet objet créé.\nVous devez d'abord lui envoyer la référence via l'inventaire d'objets créés.";
	HASNOTREF = "{r}Ce joueur ne possède pas la référence de cet objet : sa version de TRP est plus ancienne que la vôtre.";
	MUSTINSAC = "Vous ne pouvez qu'échanger des objets se trouvant dans votre sac à dos.";
	ALREADYEXCHNAGE = Joueur.." est actuellement occupé.";
	REFCIBLE = "Vous devez sélectionner un personnage.";
	ISFINGHTING = " est occupé(e) car en plein combat!";
	SHOW = "Vous ne pouvez pas montrer d'objet à cette personne.";
}

Exchange = {
	ECHANGEREF = "Envoi d'informations en cours ...";
	ECHANGEREFDONE = "Envoi d'informations terminé.";
	SENDED = "Une demande d'échange a été envoyée à ";
	SENDEDREF = "Une demande d'envoi d'informations d'objet a été envoyée à ";
	REFASKING = "Informations d'objet : Réception";
	REFASKINGMAJ = "Informations d'objet : Mise à jour";
	REFASKINGD = " souhaite vous donner {o}une mise à jour{w} des informations relatives à un objet que vous possédez déjà :\n\n";
	REFASKINGE = " souhaite vous donner {o}une mise à jour{w} des informations relatives son objet :\n\n";
	REFASKINGB = " souhaite vous envoyer des informations relatives à un objet :\n\n";
	REFASKINGBWARNINGB = "\n\n{o}Attention{w} : Le créateur de cette mise à jour est le créateur de la version que vous possédez de l'objet, cependant il existe toujours un risque que cette version soit antérieure à celle que vous possédez"
						..".\n\n{v}Acceptez vous quand même la mise à jour ?";
	REFASKINGBWARNING = "\n\n{o}Attention{w} : Le créateur de cette mise à jour est différent de celui de la version que vous possédez de l'objet.\n\n{v}Acceptez vous quand même la mise à jour ?";
	REFASKINGC = "\n\nL'envoi de ces données est nécéssaire si vous souhaitez pouvoir vous échanger ce type d'objet par la suite.\n\n{v}Acceptez vous l'envoi ?";
	
	DOCUREFASKING = "Document : Réception";
	DOCUREFASKINGMAJ = "Document : Mise à jour";
	DOCUREFASKINGD = " souhaite vous donner {o}une mise à jour{w} d'un document que vous possédez déjà :\n\n";
	DOCUREFASKINGE = " souhaite vous donner {o}une mise à jour{w} de son document :\n\n";
	DOCUREFASKINGB = " souhaite vous envoyer un document :\n\n";
	DOCUREFASKINGBWARNINGB = "\n\n{o}Attention{w} : Le créateur de cette mise à jour est le créateur de la version que vous possédez du document, cependant il existe toujours un risque que cette version soit antérieure à celle que vous possédez"
						..".\n\n{v}Acceptez vous quand même la mise à jour ?";
	DOCUREFASKINGBWARNING = "\n\n{o}Attention{w} : Le créateur de cette mise à jour n'est pas le créateur de la version que vous possédez du document.\n\n{v}Acceptez vous quand même la mise à jour ?";
	DOCUREFASKINGC = "\n\n{v}Acceptez vous l'envoi ?";
}

ObjectError = {
	NOMOUNT = "Vous n'avez pas accès à votre coffre de voyage pour le moment.";
	MUSTBOONMOUNT = "Vous devez être sur votre monture.";
	NOPLANQUE = "Vous n'avez pas de planque à cet endroit.";
}

DeleteMessages = {
	DELETEPLANQUE = "Cette action va supprimer la planque, {o}ainsi que tout objet restant encore à l'intérieur.{w}\n\n"
					.."{o}Cette action n'est pas réversible.\n\n{w}Etes vous sûr de vouloir supprimer cette planque ?";
	DELETEPLANQUEWARN = "Vous devez rester à votre planque pour la supprimer !";
	DELETEDOCUMENT = "Cette action va supprimer le document.\n\n{o}Cette action n'est pas réversible.\n\n{w}Etes vous sûr de vouloir supprimer ce document ?"
}

DocumentsTexts = {
	ECHANGETITRE = "Echange d'un document";
	ECHANGE1 = " souhaite vous envoyer un document dont le titre est :\n\n{o}\"";
	ECHANGE2 = " souhaite vous envoyer une mise à jour d'un document {o}que vous possédez déjà{w} dont le titre est :\n\n{o}\"";
	ECHANGE2WARNING = "\"{w}\n\nAttention, la mise à jour n'a pas été faite par le créateur de la version que vous possédez du document."
					.."\n\nVoulez vous accepter malgré tout cette mise à jour du document?";
	ECHANGEACCEPT = "\"{w}\n\nVoulez vous accepter ce document ?";
	EDITAUTEUR = "Edition du document";
	EDITAUTEURTEXT = "Attention, vous n'êtes pas le créateur de ce document. {o}Si vous lui apportez des modifications et que vous sauvegardez, vous en deviendrez le créateur.";
	CREATEUR = "Créateur du document : ";
	YOUCREATEUR = "Vous êtes le créateur du document";
}

CONFIGINVCONFIRM = {
	" Refus automatique de toute demande d'envoi d'objet et/ou de référence.",
	" Affichera {o}toujours{w} une invite de demande si quelqu'un veut vous envoyer un objet et/ou une référence ou une mise à jour d'une référence que vous avez déjà.",
	" Affichera {o}toujours{w} une invite de demande si quelqu'un veut vous envoyer un objet et/ou une référence sauf si la référence est connue, du même créateur et que c'est le créateur qui vous envoie la mise à jour. Dans ce"
	.." cas, la demande est automatiquement acceptée.{v} (Réglage {v}par défaut et conseillé)",
	" Les demandes de réception/mise à jour de référence sont toujours acceptées, quel que soit le créateur {r}(déconseillé).",
}

CONFIGDOCUCONFIRM = {
	" Refus automatique de toute demande d'envoi de document.",
	" Affichera {o}toujours{w} une invite de demande si quelqu'un veut vous envoyer un document ou une mise à jour d'un document que vous avez déjà.",
	" Affichera {o}toujours{w} une invite de demande si quelqu'un veut vous envoyer document sauf si le document est déjà possédé, du même créateur et que c'est le créateur qui vous envoie la mise à jour. Dans ce"
	.." cas, la demande est automatiquement acceptée. {v}(Réglage par défaut et conseillé)",
	" Les demandes de réception/mise à jour de document sont toujours acceptées, quel que soit le créateur {r}(déconseillé){w}.",
}

CONFIGDOCUCONFIRMTITLE = {
	"{r}Niveau 1 : Blocage total",
	"{o}Niveau 2 : Toujours demander",
	"{w}Niveau 3 : Oui si créateur",
	"{v}Niveau 4 : Toujours oui",
}

CONFIGINVCONFIRMTITLE = {
	"{r}Niveau 1 : Blocage total",
	"{o}Niveau 2 : Toujours demander",
	"{w}Niveau 3 : Oui si créateur",
	"{v}Niveau 4 : Toujours oui",
}

Courrier = {
	DELETEA = "{w}Êtes vous sûr de vouloir supprimer ce colis ?\n\n{o}Vous perderez à jamais son contenu !";
	DELETEB = "{w}Êtes vous sûr de vouloir supprimer ce colis ?\n\n{v}Vous récupèrerez automatiquement le contenu.";
}
