﻿TRP_Objects = {

	

	["2"] = { -- "Revolver .45"
		["Nom"] = "Revolver .45",
		["Type"] = 1,
		["SousType"] = 2,
		["Description"] = "Revolver extrêmement puissant.\nCapacité : 5 balles (calibre .45)",
		["Icone"] = "INV_Weapon_Rifle_31",
		["Poids"] = 2500;
		["Valeur"] = 50;
		["Utilisable"] = {
			["Charges"] = 5,
			["UseTooltip"] = "{[%]Tirer sur la cible<>Tirer n'importe où.}",
			["EmotePrivateOnUse"] = "{[%]Vous tirez sur %t !<>Vous vous tirez une balle dans le pied...}",
			["EmotePrivateOnDeath"] = "Votre [Revolver .45] est vide et nécéssite d'être rechargée.",
			["SoundOnUse"] = "Item\\Weapons\\Gun\\GunFire02",
			["ObjectOnDeath"] = "3",
			["Conditions"] = {
				["Cible"] = {
					["bMustAlive"] = false,
					["bMustDead"] = false,
					["bMustBeNamed"] = "",
				},
			},
		},
		["3DModel"] = "001",
	},
	["3"] = { -- "Revolver .45 : Vide"
		["Nom"] = "Revolver .45 : Vide",
		["Type"] = 1,
		["SousType"] = 2,
		["Description"] = "Revolver extrêmement puissant.\nCapacité : 5 balles (calibre .45)\nLe chargeur est vide.",
		["Icone"] = "INV_Weapon_Rifle_31",
		["Poids"] = 2250;
		["Valeur"] = 40;
		["Utilisable"] = {
			["Charges"] = 1,
			["UseTooltip"] = "Recharger le revolver",
			["EmotePrivateOnUse"] = "Vous recharger le [Revolver .45] avec 5*[Munition calibre .45]",
			["SoundOnUse"] = "Item\\Weapons\\Gun\\GunLoad02",
			["ObjectOnDeath"] = "2",
			["Conditions"] = {
				["OtherObject"] = {
					["ID"] = "4",
					["Qte"] = 5,
					["bDelete"] = true,
				},
			},
		},
		["3DModel"] = "001",
	},
	["4"] = { -- "Munition calibre .45"
		["Nom"] = "Munition calibre .45",
		["Type"] = 1,
		["SousType"] = 3,
		["Description"] = "Munition pour revolvers ou fusils calibre .45.",
		["Icone"] = "INV_Misc_Ammo_Bullet_02",
		["Poids"] = 50;
		["Valeur"] = 2;
		["3DModel"] = "002",
	},
	["8"] = { -- "Douille .45 vide"
		["Nom"] = "Douille calibre .45 : vide",
		["Type"] = 1,
		["SousType"] = 3,
		["Description"] = "C'est une douille vide, calibre .45. Si vous y placez une [Dose de poudre explosive], vous obtiendrez une [Munition calibre .45].",
		["Icone"] = "INV_Ammo_Bullet_01",
		["Poids"] = 25;
		["Valeur"] = 1;
		["Utilisable"] = {
			["Charges"] = 1,
			["UseTooltip"] = "Créer une [Munition calibre .45]",
			["EmotePrivateOnUse"] = "Vous avez créer une [Munition calibre .45].",
			["SoundOnUse"] = "",
			["ObjectOnDeath"] = "4",
			["Conditions"] = {
				["OtherObject"] = {
					["ID"] = "7",
					["Qte"] = 1,
					["bDelete"] = true,
				},
			},
		},
		["3DModel"] = "002",
	},
	["5"] = { -- "Tonnelet de poudre explosive"
		["Nom"] = "Tonnelet de poudre explosive",
		["Type"] = 8,
		["SousType"] = 3,
		["Description"] = "Un petit tonneau rempli de poudre explosive.\n<Tenir hors porté de toute source de chaleur!>",
		["Icone"] = "INV_Cask_02",
		["Poids"] = 3000;
		["Valeur"] = 200;
		["Utilisable"] = {
			["Charges"] = 100,
			["UseTooltip"] = "Retirer une dose de poudre",
			["ObjectOnDeath"] = "6",
			["ObjectOnUse"] = "7",
		},
		["3DModel"] = "003",
	},
	["6"] = { -- "Tonnelet en bois fin"
		["Nom"] = "Tonnelet en bois fin",
		["Type"] = 8,
		["SousType"] = 3,
		["Description"] = "Un petit tonneau en bois fin d'une capacité de +- 3 litres.",
		["Icone"] = "INV_Cask_03",
		["Poids"] = 500;
		["Valeur"] = 25;
		["3DModel"] = "005",
	},
	["7"] = { -- "Poudre explosive"
		["Nom"] = "Dose de poudre explosive",
		["Type"] = 7,
		["SousType"] = 8,
		["Description"] = "Mélange de divers minéraux en poudre. Hautement explosif.\nCette poudre est généralement utilisée pour la création de bombes et de munitions.",
		["Icone"] = "INV_Misc_Dust_01",
		["Poids"] = 25;
		["Valeur"] = 2;
		["3DModel"] = "007",
	},
	
};

TRP_OBJETS_MODEL = {
	["001"] = {["Nom"] = "Arme : Fusil Nain 1",["Url"] = "World\\Generic\\dwarf\\passive doodads\\guns\\rifledwarven.mdx",["Scale"] = 1},
	["002"] = {["Nom"] = "Munition : Boite Rouge 1",["Url"] = "World\\Generic\\human\\passive doodads\\gunshop\\gunshopammoboxred.mdx",["Scale"] = 3},
	["003"] = {["Nom"] = "Tonneau : Poudre 1",["Url"] = "World\\Generic\\human\\passive doodads\\gunshop\\gunshoppowderkegopen.mdx",["Scale"] = 1.5},
	["004"] = {["Nom"] = "Tonneau : Poudre 2",["Url"] = "World\\Generic\\dwarf\\passive doodads\\powderkegs\\powderkeg01.mdx",["Scale"] = 1.5},
	["005"] = {["Nom"] = "Tonneau : Bois 1",["Url"] = "World\\Azeroth\\westfall\\passivedoodads\\barrel\\westfallbarrel01.mdx",["Scale"] = 1.5},
	["006"] = {["Nom"] = "Tonneau : Métal 1",["Url"] = "World\\Generic\\dwarf\\passive doodads\\barrels\\dwarvenbarrel01.mdx",["Scale"] = 1},
	["007"] = {["Nom"] = "Sac : Grain 1",["Url"] = "World\\Generic\\human\\passive doodads\\sacks\\plaguedgrainsack02.mdx",["Scale"] = 2},
	["008"] = {["Nom"] = "Sac : Grain 2",["Url"] = "World\\Generic\\dwarf\\passive doodads\\tavernstuff\\grainsacs02.mdx",["Scale"] = 1,["Pos"] = {X = 0,Y = 0.2,Z = 0}},
	["009"] = {["Nom"] = "Potion : Noir 1",["Url"] = "Spells\\Potion_black01_spellobject.mdx",["Scale"] = 4},
	["010"] = {["Nom"] = "Potion : Noir 2",["Url"] = "Spells\\Potion_black02_spellobject.mdx",["Scale"] = 4},
	["011"] = {["Nom"] = "Potion : Noir 3",["Url"] = "Spells\\Potion_black03_spellobject.mdx",["Scale"] = 4},
	["012"] = {["Nom"] = "Potion : Noir 4",["Url"] = "Spells\\Potion_black04_spellobject.mdx",["Scale"] = 4},
	["013"] = {["Nom"] = "Potion : Noir 5",["Url"] = "Spells\\Potion_black05_spellobject.mdx",["Scale"] = 4},
	["014"] = {["Nom"] = "Potion : Bleue 1",["Url"] = "Spells\\Potion_blue01_spellobject.mdx",["Scale"] = 4},
	["015"] = {["Nom"] = "Potion : Bleue 2",["Url"] = "Spells\\Potion_blue02_spellobject.mdx",["Scale"] = 4},
	["016"] = {["Nom"] = "Potion : Verte 1",["Url"] = "Spells\\Potion_green01_spellobject.mdx",["Scale"] = 4},
	["017"] = {["Nom"] = "Potion : Verte 2",["Url"] = "Spells\\Potion_green02_spellobject.mdx",["Scale"] = 4},
	["018"] = {["Nom"] = "Potion : Verte 3",["Url"] = "Spells\\Potion_green03_spellobject.mdx",["Scale"] = 4},
	["019"] = {["Nom"] = "Potion : Verte 4",["Url"] = "Spells\\Potion_green04_spellobject.mdx",["Scale"] = 4},
	["020"] = {["Nom"] = "Potion : Pourpre 1",["Url"] = "Spells\\Potion_purple01_spellobject.mdx",["Scale"] = 4},
	["021"] = {["Nom"] = "Potion : Pourpre 2",["Url"] = "Spells\\Potion_purple02_spellobject.mdx",["Scale"] = 4},
	["022"] = {["Nom"] = "Potion : Pourpre 3",["Url"] = "Spells\\Potion_purple03_spellobject.mdx",["Scale"] = 4},
	["023"] = {["Nom"] = "Potion : Rouge 1",["Url"] = "Spells\\Potion_red01_spellobject.mdx",["Scale"] = 4},
	["024"] = {["Nom"] = "Potion : Rouge 2",["Url"] = "Spells\\Potion_red02_spellobject.mdx",["Scale"] = 4},
	["025"] = {["Nom"] = "Potion : Rouge 3",["Url"] = "Spells\\Potion_red03_spellobject.mdx",["Scale"] = 4},
	["026"] = {["Nom"] = "Vase : Elfe de Sang 1",["Url"] = "World\\Generic\\bloodelf\\passive doodads\\be_jar_01.mdx",["Scale"] = 1},
	["027"] = {["Nom"] = "Vase : Elfe de Sang 2",["Url"] = "World\\Generic\\bloodelf\\passive doodads\\be_jar_02.mdx",["Scale"] = 1},
	["028"] = {["Nom"] = "Caisse : Ronde Elfe de Sang 1",["Url"] = "World\\Generic\\bloodelf\\passive doodads\\bl_round_crate_001.mdx",["Scale"] = 1.5},
	["029"] = {["Nom"] = "Caisse : Ronde Elfe de Sang 2",["Url"] = "World\\Generic\\bloodelf\\passive doodads\\bl_round_crate_002.mdx",["Scale"] = 1.5},
	["030"] = {["Nom"] = "Caisse : Ronde Elfe de Sang Ouverte",["Url"] = "World\\Generic\\bloodelf\\passive doodads\\bl_round_crate_003.mdx",["Scale"] = 1.5},
	["031"] = {["Nom"] = "Caisse : Ronde Elfe de Sang 3",["Url"] = "World\\Generic\\bloodelf\\passive doodads\\bl_round_crate_004_open.mdx",["Scale"] = 1.5},
	["032"] = {["Nom"] = "Caisse : Carrée Elfe de Sang 1",["Url"] = "World\\Generic\\bloodelf\\passive doodads\\bl_sq_crate_001.mdx",["Scale"] = 1.5},
	["033"] = {["Nom"] = "Caisse : Carrée Elfe de Sang 2",["Url"] = "World\\Generic\\bloodelf\\passive doodads\\bl_sq_crate_002.mdx",["Scale"] = 1.5},
	["034"] = {["Nom"] = "Caisse : Carrée Elfe de Sang 3",["Url"] = "World\\Generic\\bloodelf\\passive doodads\\bl_sq_crate_003.mdx",["Scale"] = 1.5},
	["035"] = {["Nom"] = "Caisse : Carrée Ouverte Elfe de Sang",["Url"] = "World\\Generic\\bloodelf\\passive doodads\\bl_sq_crate_004_open.mdx",["Scale"] = 1.5},
	["036"] = {["Nom"] = "Caisse : Sombrefer 1",["Url"] = "World\\Generic\\darkirondwarf\\passive doodads\\crates\\darkironcrate01.mdx",["Scale"] = 0.5,["Pos"] = {X = 0,Y = 0,Z = 0.75}},
	["037"] = {["Nom"] = "Caisse : Sombrefer 2",["Url"] = "World\\Generic\\darkirondwarf\\passive doodads\\crates\\darkironcrate02.mdx",["Scale"] = 0.5,["Pos"] = {X = 0,Y = 0,Z = 0.75}},
	["038"] = {["Nom"] = "Caisse : Sombrefer 1 cassée",["Url"] = "World\\Generic\\darkirondwarf\\passive doodads\\crates\\darkironcratebroken01.mdx",["Scale"] = 0.5,["Pos"] = {X = 0,Y = 0,Z = 0.75}},
	["039"] = {["Nom"] = "Caisse : Sombrefer 2 cassée",["Url"] = "World\\Generic\\darkirondwarf\\passive doodads\\crates\\darkironcratebroken02.mdx",["Scale"] = 0.5,["Pos"] = {X = 0,Y = 0,Z = 0.75}},
	["040"] = {["Nom"] = "Fut : Sombrefer 1",["Url"] = "World\\Generic\\darkirondwarf\\passive doodads\\kegs\\darkironkeg01.mdx",["Scale"] = 0.5,["Pos"] = {X = 0,Y = 0,Z = 0.75}},
	["041"] = {["Nom"] = "Fut : Sombrefer 1 cassé",["Url"] = "World\\Generic\\darkirondwarf\\passive doodads\\kegs\\darkironkegbroken01.mdx",["Scale"] = 0.35,["Pos"] = {X = 0,Y = -0.4,Z = 0.75}},
	["161"] = {["Nom"] = "Fut : Bière 1",["Url"] = "World\\Generic\\human\\passive doodads\\beerkegs\\beerkeg02.mdx",["Scale"] = 1,["Pos"] = {X = 0,Y = 0,Z = 0}},
	["042"] = {["Nom"] = "Tissu : Bleu abimé 1",["Url"] = "World\\Generic\\darkirondwarf\\passive doodads\\tapestries\\darkirontapestry02.mdx",["Scale"] = 0.25,["Pos"] = {X = 0,Y = -0.2,Z = 3}},
	["043"] = {["Nom"] = "Tissu : Bleu abimé 2",["Url"] = "World\\Generic\\darkirondwarf\\passive doodads\\tapestries\\darkirontapestry03.mdx",["Scale"] = 0.25,["Pos"] = {X = 0,Y = -0.2,Z = 3}},
	["044"] = {["Nom"] = "Bois : Tas de planche 1",["Url"] = "World\\Generic\\darkirondwarf\\passive doodads\\woodpiles\\darkironwoodpile01.mdx",["Scale"] = 0.5,["Pos"] = {X = 0,Y = 0,Z = 0.75}},
	["045"] = {["Nom"] = "Bois : Planche 1",["Url"] = "World\\Generic\\dwarf\\passive doodads\\excavationbarrierplank\\excavationbarrierplank.mdx",["Scale"] = 0.15,["Pos"] = {X = 0,Y = 0.15,Z = 1}},
	["046"] = {["Nom"] = "Explosifs : Dynamite Paquet 1",["Url"] = "World\\Generic\\dwarf\\passive doodads\\dynamite\\gunshopdynamitebundle.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["047"] = {["Nom"] = "Lampe : Minage 1",["Url"] = "World\\Generic\\dwarf\\passive doodads\\lanterns\\mininglamp01.mdx",["Scale"] = 1},
	["048"] = {["Nom"] = "Lampe : Gyrophare 1",["Url"] = "World\\Generic\\gnome\\passive doodads\\hazardlights\\gnomehazardlight01.mdx",["Scale"] = 1,["Pos"] = {X = 0,Y = 0,Z = 0.2}},
	["049"] = {["Nom"] = "Lampe : Gyrophare 2",["Url"] = "World\\Generic\\gnome\\passive doodads\\hazardlights\\gnomehazardlight02.mdx",["Scale"] = 1,["Pos"] = {X = 0,Y = 0,Z = 0.2}},
	["050"] = {["Nom"] = "Lampe : Gyrophare 3",["Url"] = "World\\Generic\\gnome\\passive doodads\\hazardlights\\gnomehazardlightred_02.mdx",["Scale"] = 1,["Pos"] = {X = 0,Y = 0,Z = 0.2}},
	["051"] = {["Nom"] = "Lampe : Maintenance Allumée",["Url"] = "World\\Generic\\gnome\\passive doodads\\lights\\gnomemaintenancelight01.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.25}},
	["052"] = {["Nom"] = "Lampe : Maintenance Eteinte",["Url"] = "World\\Generic\\gnome\\passive doodads\\lights\\gnomemaintenancelight02.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.25}},
	["053"] = {["Nom"] = "Archeologie : Fossile 1",["Url"] = "World\\Generic\\dwarf\\passive doodads\\museum\\fossil01.mdx",["Scale"] = 0.75,["Pos"] = {X = 0,Y = 0,Z = 0.1}},
	["054"] = {["Nom"] = "Plateau : Or Orné 1",["Url"] = "World\\Generic\\dwarf\\passive doodads\\platters\\plattergoldornate01.mdx",["Scale"] = 1},
	["055"] = {["Nom"] = "Plateau : Or 1",["Url"] = "World\\Generic\\dwarf\\passive doodads\\platters\\plattergoldsimple01.mdx",["Scale"] = 1},
	["056"] = {["Nom"] = "Vaisselle : Chope Naine 1",["Url"] = "World\\Generic\\dwarf\\passive doodads\\steins\\dwarvenstein01.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.3}},
	["057"] = {["Nom"] = "Vaisselle : Chope Naine 2",["Url"] = "World\\Generic\\dwarf\\passive doodads\\steins\\dwarvenstein02.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.3}},
	["058"] = {["Nom"] = "Alcool : Fut Nain 1",["Url"] = "World\\Generic\\dwarf\\passive doodads\\tavernstuff\\alekegsingle.mdx",["Scale"] = 0.85},
	["059"] = {["Nom"] = "Outils : Boite à outils 1",["Url"] = "World\\Generic\\dwarf\\passive doodads\\tools\\lunchbox01.mdx",["Scale"] = 1.75},
	["060"] = {["Nom"] = "Outils : Boite à outils 2",["Url"] = "World\\Generic\\dwarf\\passive doodads\\tools\\toolbox01.mdx",["Scale"] = 1.70},
	["061"] = {["Nom"] = "Outils : Maillet 1",["Url"] = "World\\Generic\\dwarf\\passive doodads\\tools\\mallet01.mdx",["Scale"] = 1.75},
	["062"] = {["Nom"] = "Outils : Tournevis 1",["Url"] = "World\\Generic\\dwarf\\passive doodads\\tools\\screwdriver01.mdx",["Scale"] = 1.75},
	["063"] = {["Nom"] = "Outils : Clé 1",["Url"] = "World\\Generic\\dwarf\\passive doodads\\tools\\wrench01.mdx",["Scale"] = 1.75},
	["064"] = {["Nom"] = "Outils : Seau Gnome 1",["Url"] = "World\\Generic\\gnome\\passive doodads\\buckets\\gnomebucket01.mdx",["Scale"] = 1.5},
	["065"] = {["Nom"] = "Outils : Boite à outils 3",["Url"] = "World\\Generic\\gnome\\passive doodads\\buckets\\gnomebucket02.mdx",["Scale"] = 1.5},
	["066"] = {["Nom"] = "Outils : Seau Gnome 2",["Url"] = "World\\Generic\\gnome\\passive doodads\\buckets\\gnomebucket03.mdx",["Scale"] = 1.5},
	["067"] = {["Nom"] = "Outils : Seau Gnome 3",["Url"] = "World\\Generic\\gnome\\passive doodads\\buckets\\gnomebucket04.mdx",["Scale"] = 1.5},
	["068"] = {["Nom"] = "Outils : Seau Gnome 4",["Url"] = "World\\Generic\\gnome\\passive doodads\\buckets\\gnomebucket05.mdx",["Scale"] = 1.5},
	["069"] = {["Nom"] = "Outils : Marteau-piqueur 1",["Url"] = "World\\Generic\\gnome\\passive doodads\\tools\\gnometool01.mdx",["Scale"] = 1.5},
	["070"] = {["Nom"] = "Outils : Marteau-piqueur 2",["Url"] = "World\\Generic\\gnome\\passive doodads\\tools\\gnometool02.mdx",["Scale"] = 1.5},
	["071"] = {["Nom"] = "Outils : Outil Gnome 1",["Url"] = "World\\Generic\\gnome\\passive doodads\\tools\\gnometool03.mdx",["Scale"] = 1.5},
	["072"] = {["Nom"] = "Outils : Outil Gnome 2",["Url"] = "World\\Generic\\gnome\\passive doodads\\tools\\gnometool04.mdx",["Scale"] = 1.5},
	["073"] = {["Nom"] = "Outils : Outil Gnome 3",["Url"] = "World\\Generic\\gnome\\passive doodads\\tools\\gnometool05.mdx",["Scale"] = 1.5},
	["074"] = {["Nom"] = "Outils : Outil Gnome 4",["Url"] = "World\\Generic\\gnome\\passive doodads\\tools\\gnometool06.mdx",["Scale"] = 1.5},
	["075"] = {["Nom"] = "Mécanique : Rouage 1",["Url"] = "World\\Generic\\gnome\\passive doodads\\gears&levers\\gnomebiggear.mdx",["Scale"] = 0.5},
	["076"] = {["Nom"] = "Mécanique : Rouage 2",["Url"] = "World\\Generic\\gnome\\passive doodads\\gears&levers\\gnomesmallgear.mdx",["Scale"] = 1.5},
	["077"] = {["Nom"] = "Mécanique : Roue 1",["Url"] = "World\\Generic\\gnome\\passive doodads\\gears&levers\\gnomemcwheel.mdx",["Scale"] = 0.5},
	["078"] = {["Nom"] = "Mécanique : Levier 1",["Url"] = "World\\Generic\\gnome\\passive doodads\\gears&levers\\gnomelever.mdx",["Scale"] = 1.25},
	["079"] = {["Nom"] = "Mécanique : Jauge 1",["Url"] = "World\\Generic\\gnome\\passive doodads\\gears&levers\\gnomegauge01.mdx",["Scale"] = 3,["Pos"] = {X = 0,Y = 0,Z = -0.45}},
	["080"] = {["Nom"] = "Mécanique : Vis 1",["Url"] = "World\\Generic\\gnome\\passive doodads\\parts\\gnomescrew01.mdx",["Scale"] = 0.5},
	["081"] = {["Nom"] = "Mécanique : Vis 2",["Url"] = "World\\Generic\\gnome\\passive doodads\\parts\\gnomescrew02.mdx",["Scale"] = 0.5},
	["082"] = {["Nom"] = "Mécanique : Vis 3",["Url"] = "World\\Generic\\gnome\\passive doodads\\parts\\gnomescrew03.mdx",["Scale"] = 0.5},
	["083"] = {["Nom"] = "Mécanique : Vis 4",["Url"] = "World\\Generic\\gnome\\passive doodads\\parts\\gnomescrew04.mdx",["Scale"] = 0.5},
	["084"] = {["Nom"] = "Mécanique : Vis 5",["Url"] = "World\\Generic\\gnome\\passive doodads\\parts\\gnomescrew05.mdx",["Scale"] = 0.5},
	["085"] = {["Nom"] = "Mécanique : Vis 6",["Url"] = "World\\Generic\\gnome\\passive doodads\\parts\\gnomescrew06.mdx",["Scale"] = 0.5},
	["086"] = {["Nom"] = "Mécanique : Vis 7",["Url"] = "World\\Generic\\gnome\\passive doodads\\parts\\gnomescrew07.mdx",["Scale"] = 0.5},
	["087"] = {["Nom"] = "Mécanique : Vis 8",["Url"] = "World\\Generic\\gnome\\passive doodads\\parts\\gnomescrew08.mdx",["Scale"] = 0.5},
	["088"] = {["Nom"] = "Mécanique : Vis 9",["Url"] = "World\\Generic\\gnome\\passive doodads\\parts\\gnomescrew09.mdx",["Scale"] = 0.5},
	["089"] = {["Nom"] = "Mécanique : Panneau de Contrôle 1",["Url"] = "World\\Generic\\goblin\\passivedoodads\\controlpanel\\goblincontrolpanel.mdx",["Scale"] = 1,["Pos"] = {X = 0,Y = 0.1,Z = 0.1}},
	["090"] = {["Nom"] = "Métal : Morceau 1",["Url"] = "World\\Generic\\gnome\\passive doodads\\parts\\gnomesteelplate01.mdx",["Scale"] = 0.5},
	["091"] = {["Nom"] = "Métal : Morceau 2",["Url"] = "World\\Generic\\gnome\\passive doodads\\parts\\gnomesteelplate02.mdx",["Scale"] = 0.5},
	["092"] = {["Nom"] = "Métal : Morceau 3",["Url"] = "World\\Generic\\gnome\\passive doodads\\parts\\gnomesteelplate03.mdx",["Scale"] = 0.5},
	["093"] = {["Nom"] = "Métal : Morceau 4",["Url"] = "World\\Generic\\gnome\\passive doodads\\parts\\gnomesteelplate04.mdx",["Scale"] = 0.5},
	["094"] = {["Nom"] = "Métal : Morceau 5",["Url"] = "World\\Generic\\gnome\\passive doodads\\parts\\gnomesteelplate05.mdx",["Scale"] = 0.5},
	["095"] = {["Nom"] = "Trophé : Cerf 1",["Url"] = "World\\Generic\\human\\passive doodads\\animalheads\\duskwooddeerhead01.mdx",["Scale"] = 1,["Pos"] = {X = 0,Y = 0.15,Z = 0.2}},
	["096"] = {["Nom"] = "Trophé : Dragon 1",["Url"] = "World\\Generic\\human\\passive doodads\\animalheads\\head_mounted_dragon.mdx",["Scale"] = 0.3,["Pos"] = {X = 0,Y = 0.10,Z = -1.5}},
	["097"] = {["Nom"] = "Trophé : Gnome 1",["Url"] = "World\\Generic\\human\\passive doodads\\animalheads\\head_mounted_gnome.mdx",["Scale"] = 3},
	["098"] = {["Nom"] = "Trophé : Pinguin 1",["Url"] = "World\\Generic\\human\\passive doodads\\animalheads\\head_mounted_penguin.mdx",["Scale"] = 2},
	["099"] = {["Nom"] = "Trophé : Mamouth 1",["Url"] = "World\\Generic\\human\\passive doodads\\animalheads\\head_mounted_mammoth.mdx",["Scale"] = 0.35,["Pos"] = {X = 0,Y = 0,Z = -0.3}},
	["100"] = {["Nom"] = "Trophé : Brochepelle 1",["Url"] = "World\\Generic\\human\\passive doodads\\animalheads\\head_mounted_shoveltusk.mdx",["Scale"] = 1},
	["101"] = {["Nom"] = "Plaque : Brassard 1",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorbracerblue.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = -0.25}},
	["102"] = {["Nom"] = "Plaque : Brassard 2",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorbracergold.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = -0.25}},
	["103"] = {["Nom"] = "Plaque : Brassard 3",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorbracersilver.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = -0.25}},
	["104"] = {["Nom"] = "Plaque : Brassard 4",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorbracertrim.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = -0.25}},
	["105"] = {["Nom"] = "Plaque : Torse 1",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorbreastplateblue.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["106"] = {["Nom"] = "Plaque : Torse 2",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorbreastplategold.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["107"] = {["Nom"] = "Plaque : Torse 3",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorbreastplategreen.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["108"] = {["Nom"] = "Plaque : Torse 4",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorbreastplatetrim.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["121"] = {["Nom"] = "Plaque : Casque 1",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorhelmbluevisordown.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = 0.25}},
	["122"] = {["Nom"] = "Plaque : Casque 2",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorhelmbluevisorup.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = 0.25}},
	["123"] = {["Nom"] = "Plaque : Casque 3",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorhelmgold.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = 0.25}},
	["124"] = {["Nom"] = "Plaque : Casque 4",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorhelmgreen.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = 0.25}},
	["125"] = {["Nom"] = "Plaque : Casque 5",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorhelmgreenflat.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = 0.25}},
	["126"] = {["Nom"] = "Plaque : Casque 6",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorhelmtrim.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = 0.25}},
	["127"] = {["Nom"] = "Plaque : Casque 7",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorhelmtrimflat.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = 0.25}},
	["128"] = {["Nom"] = "Cuir : Brassard 1",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleatherbracerblack.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = -0.25}},
	["129"] = {["Nom"] = "Cuir : Brassard 2",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleatherbracerbrown.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = -0.25}},
	["130"] = {["Nom"] = "Cuir : Brassard 3",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleatherbracerdark.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = -0.25}},
	["131"] = {["Nom"] = "Cuir : Brassard 4",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleatherbracerorange.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = -0.25}},
	["132"] = {["Nom"] = "Cuir : Casque 1",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleatherhelmblack.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = 0.25}},
	["133"] = {["Nom"] = "Cuir : Casque 2",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleatherhelmblackflat.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = 0.25}},
	["134"] = {["Nom"] = "Cuir : Casque 3",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleatherhelmbrownflat.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = 0.25}},
	["135"] = {["Nom"] = "Cuir : Renfort 1",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleatherlegplatebrown.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = -0.05}},
	["136"] = {["Nom"] = "Cuir : Renfort 2",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleatherlegplatedark.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = -0.05}},
	["137"] = {["Nom"] = "Cuir : Renfort 3",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleatherlegplateblack.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = -0.05}},
	["138"] = {["Nom"] = "Cuir : Renfort 4",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleatherlegplateorange.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = -0.05}},
	["139"] = {["Nom"] = "Cuir : Torse 1",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleathershirtbrown.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["140"] = {["Nom"] = "Cuir : Torse 2",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleathershirtorange.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["141"] = {["Nom"] = "Cuir : Torse 3",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleathershirtdark.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["142"] = {["Nom"] = "Cuir : Torse 4",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleathershirtblack.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["143"] = {["Nom"] = "Cuir : Épaule 1",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleathershoulderblack.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["144"] = {["Nom"] = "Cuir : Épaule 2",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleathershoulderdark.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["145"] = {["Nom"] = "Cuir : Épaule 3",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorleathershoulderorange.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["146"] = {["Nom"] = "Plaque : Épaule 1",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorshoulderblue.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["147"] = {["Nom"] = "Plaque : Épaule 2",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorshouldergold.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["148"] = {["Nom"] = "Plaque : Épaule 3",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorshouldersilver.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["149"] = {["Nom"] = "Plaque : Épaule 4",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorshouldertrim.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["150"] = {["Nom"] = "Plaque : Renfort 1",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorlegplateblue.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = 0}},
	["151"] = {["Nom"] = "Plaque : Renfort 2",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorlegplategold.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = 0}},
	["152"] = {["Nom"] = "Plaque : Renfort 3",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorlegplatetrim.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = 0}},
	["153"] = {["Nom"] = "Plaque : Renfort 4",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorlegplatesilver.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = 0}},
	["154"] = {["Nom"] = "Maille : Cotte Argent Courte 1",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armormailhangingblue.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = 0.25}},
	["155"] = {["Nom"] = "Maille : Cotte Or Courte 1",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armormailhanginggold.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.25}},
	["156"] = {["Nom"] = "Maille : Cotte Bronze Courte 1",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armormailhangingred.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.25}},
	["157"] = {["Nom"] = "Maille : Cotte Argent Longue 1",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armormailhangingbluelong.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.35}},
	["158"] = {["Nom"] = "Maille : Cotte Or Longue 1",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armormailhanginggoldlong.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.35}},
	["159"] = {["Nom"] = "Maille : Cotte Bronze Longue 1",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armormailhangingredlong.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.35}},
	["109"] = {["Nom"] = "Livre : Nain 1",["Url"] = "World\\Generic\\human\\passive doodads\\books\\book_dwarf_01.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["110"] = {["Nom"] = "Livre : Nain 2",["Url"] = "World\\Generic\\human\\passive doodads\\books\\book_dwarf_02.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["111"] = {["Nom"] = "Livre : Nain 3",["Url"] = "World\\Generic\\human\\passive doodads\\books\\book_dwarf_03.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["112"] = {["Nom"] = "Livre : Nain 4",["Url"] = "World\\Generic\\human\\passive doodads\\books\\book_dwarf_04.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["113"] = {["Nom"] = "Livre : Humain 1",["Url"] = "World\\Generic\\human\\passive doodads\\books\\book_human_01.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["114"] = {["Nom"] = "Livre : Humain 2",["Url"] = "World\\Generic\\human\\passive doodads\\books\\book_human_02.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["115"] = {["Nom"] = "Livre : Humain 3",["Url"] = "World\\Generic\\human\\passive doodads\\books\\book_human_03.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["116"] = {["Nom"] = "Livre : Humain 4",["Url"] = "World\\Generic\\human\\passive doodads\\books\\book_human_04.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["117"] = {["Nom"] = "Livre : Troll 1",["Url"] = "World\\Generic\\human\\passive doodads\\books\\book_troll_01.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["118"] = {["Nom"] = "Livre : Troll 2",["Url"] = "World\\Generic\\human\\passive doodads\\books\\book_troll_02.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["119"] = {["Nom"] = "Livre : Troll 3",["Url"] = "World\\Generic\\human\\passive doodads\\books\\book_troll_03.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["120"] = {["Nom"] = "Livre : Troll 4",["Url"] = "World\\Generic\\human\\passive doodads\\books\\book_troll_04.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["160"] = {["Nom"] = "Prison : Boulet 1",["Url"] = "World\\Generic\\human\\passive doodads\\ballandchain\\ballandchain01.mdx",["Scale"] = 1,["Pos"] = {X = 0,Y = 0.3,Z = 0}},
	["162"] = {["Nom"] = "Livre : Fermé 1",["Url"] = "World\\Generic\\human\\passive doodads\\books\\bookmedium01.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.3}},
	["163"] = {["Nom"] = "Livre : Fermé 2",["Url"] = "World\\Generic\\human\\passive doodads\\books\\bookmedium02.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.3}},
	["164"] = {["Nom"] = "Livre : Fermé 3",["Url"] = "World\\Generic\\human\\passive doodads\\books\\bookmedium03.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.3}},
	["165"] = {["Nom"] = "Livre : Fermé 4",["Url"] = "World\\Generic\\human\\passive doodads\\books\\bookmedium04.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.3}},
	["166"] = {["Nom"] = "Livre : Fermé 5",["Url"] = "World\\Generic\\human\\passive doodads\\books\\bookmedium05.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.3}},
	["167"] = {["Nom"] = "Livre : Humain 5",["Url"] = "World\\Generic\\human\\passive doodads\\books\\bookmedium06.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["168"] = {["Nom"] = "Livre : Humain 6",["Url"] = "World\\Generic\\human\\passive doodads\\books\\bookmedium07.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["169"] = {["Nom"] = "Livre : Ouvert 1",["Url"] = "World\\Generic\\human\\passive doodads\\books\\booksmallopen01.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["170"] = {["Nom"] = "Livre : Ouvert 2",["Url"] = "World\\Generic\\human\\passive doodads\\books\\booksmallopen02.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["171"] = {["Nom"] = "Livre : Ouvert 3",["Url"] = "World\\Generic\\human\\passive doodads\\books\\booksmallopen03.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["172"] = {["Nom"] = "Livre : Ouvert 4",["Url"] = "World\\Generic\\human\\passive doodads\\books\\booksmallopen04.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["173"] = {["Nom"] = "Livre : Ouvert 5",["Url"] = "World\\Generic\\human\\passive doodads\\books\\booksmallopen05.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["174"] = {["Nom"] = "Alchimie : Bouteille 1",["Url"] = "World\\Generic\\human\\passive doodads\\bottles\\bottle01.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.25}},
	["175"] = {["Nom"] = "Alchimie : Bouteille Fumée 1",["Url"] = "World\\Generic\\human\\passive doodads\\bottles\\bottlesmoke.mdx",["Scale"] = 1.5,["Pos"] = {X = 0,Y = 0,Z = -0.2}},
	["176"] = {["Nom"] = "Alchimie : Bouteille 2",["Url"] = "World\\Generic\\human\\passive doodads\\bottles\\greenbottle02.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = -0.35}},
	["177"] = {["Nom"] = "Alchimie : Bouteille 2 Cassés",["Url"] = "World\\Generic\\human\\passive doodads\\bottles\\greenbottle01.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = -0.3,Z = -0.2}},
	["178"] = {["Nom"] = "Outils : Seau 1",["Url"] = "World\\Generic\\human\\passive doodads\\buckets\\bucket.mdx",["Scale"] = 1,["Pos"] = {X = 0,Y = 0,Z = 0}},
	["179"] = {["Nom"] = "Outils : Seau 2",["Url"] = "World\\Generic\\human\\passive doodads\\buckets\\cavekoboldbucket.mdx",["Scale"] = 2,["Pos"] = {X = 0,Y = 0,Z = -0.25}},
	["180"] = {["Nom"] = "Lampe : Chandelier 1",["Url"] = "World\\Generic\\human\\passive doodads\\candelabras\\generalcandelabra01.mdx",["Scale"] = 1.3,["Pos"] = {X = 0,Y = 0,Z = -0}},
	["181"] = {["Nom"] = "Cuisine : Chaudron 1",["Url"] = "World\\Generic\\human\\passive doodads\\couldrons\\cauldronempty.mdx",["Scale"] = 0.8,["Pos"] = {X = 0,Y = -0.15,Z = -0}},
	["182"] = {["Nom"] = "Couture : Tissu Vert 1",["Url"] = "World\\Generic\\human\\passive doodads\\cloth\\clothboltgreen.mdx",["Scale"] = 1.3,["Pos"] = {X = 0,Y = 0,Z = -0}},
	["183"] = {["Nom"] = "Couture : Tissu Rouge 1",["Url"] = "World\\Generic\\human\\passive doodads\\cloth\\clothboltred.mdx",["Scale"] = 1.3,["Pos"] = {X = 0,Y = 0,Z = -0}},
	["184"] = {["Nom"] = "Couture : Tissu Blanc 1",["Url"] = "World\\Generic\\human\\passive doodads\\cloth\\clothboltwhite.mdx",["Scale"] = 1.3,["Pos"] = {X = 0,Y = 0,Z = -0}},
	["185"] = {["Nom"] = "Couture : Fil Bleu 1",["Url"] = "World\\Generic\\human\\passive doodads\\cloth\\clothspoolblue.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = -0.45}},
	["186"] = {["Nom"] = "Couture : Fil Bleu 2",["Url"] = "World\\Generic\\human\\passive doodads\\cloth\\clothspoolbluelow.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = -0.45}},
	["187"] = {["Nom"] = "Couture : Fil Rouge 1",["Url"] = "World\\Generic\\human\\passive doodads\\cloth\\clothspoolredlow.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = -0.45}},
	["188"] = {["Nom"] = "Couture : Fil Jaune 1",["Url"] = "World\\Generic\\human\\passive doodads\\cloth\\clothspoolyellow.mdx",["Scale"] = 5,["Pos"] = {X = 0,Y = 0,Z = -0.45}},
	["189"] = {["Nom"] = "Couture : Fil Bleu 3",["Url"] = "World\\Generic\\human\\passive doodads\\cloth\\clothyarnblue.mdx",["Scale"] = 3,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["190"] = {["Nom"] = "Couture : Fil Bleu 4",["Url"] = "World\\Generic\\human\\passive doodads\\cloth\\clothyarnbluelow.mdx",["Scale"] = 3,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["191"] = {["Nom"] = "Couture : Fil Rouge 2",["Url"] = "World\\Generic\\human\\passive doodads\\cloth\\clothyarnredlow.mdx",["Scale"] = 3,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	["192"] = {["Nom"] = "Couture : Fil Jaune 2",["Url"] = "World\\Generic\\human\\passive doodads\\cloth\\clothyarnyellow.mdx",["Scale"] = 3,["Pos"] = {X = 0,Y = 0,Z = -0.1}},
	
	
	
	
	-- 121
	["xxx"] = {["Nom"] = "Test",["Url"] = "World\\Generic\\human\\passive doodads\\armor\\armorhelmbluevisordown.mdx",["Scale"] = 2.5,["Pos"] = {X = 0,Y = 0,Z = 0.25}},
}

TRP_SacsADos = {
	["1"] = {
		["Nom"] = "Sac de voyageur standard",
		["Poids"] = 500,
		["Resistance"] = 25,
		["Icone"] = "INV_Misc_Bag_07",
		["Description"] = "Un sac \195\165 dos de voyage constitué de tissu et de lanières de cuir. Pas très résistant mais léger!",
	}
}

TRP_CoffreMonture = {
	["1"] = {
		["Nom"] = "Petit coffre en bois",
		["Poids"] = 1500,
		["Resistance"] = 60,
		["Icone"] = "INV_Box_01",
		["Description"] = "Un petit coffre fait de bois avec quelques renforts de fer. Parfait pour être facilement transportable sur une monture.",
	}
}

TRP_ObjetCategorie = {
	{
		Nom = "Arme",
		SousCategorie = {
			"Aucune",
			"Arme à Feu",
			"Munition",
			"Arme Blanche",
		},
	},
	{
		Nom = "Art",
		SousCategorie = {
			"Aucune",
			"Sculpture",
			"Peinture",
			"Dessin",
		},
	},
	{
		Nom = "Artefact",
		SousCategorie = {
			"Aucune",
			"Relique",
			"Objet Magique",
			"Objet Maudit",
		},
	},
	{
		Nom = "Carte",
		SousCategorie = {
			"Aucune",
		},
	},
	{
		Nom = "Consommable",
		SousCategorie = {
			"Aucune",
			"Boisson",
			"Nourriture",
			"Médicament",
			"Potion",
			"Drogue",
		},
	},
	{
		Nom = "Littérature",
		SousCategorie = {
			"Aucune",
			"Biographie",
			"Histoire",
			"Conte",
			"Légende",
			"Mythe",
			"Poème",
			"Journal",
		},
	},
	{
		Nom = "Matière Première",
		SousCategorie = {
			"Aucune",
			"Tissu",
			"Pierre",
			"Bois",
			"Acier",
			"Or",
			"Cuir",
			"Poudre",
		},
	},
	{
		Nom = "Objet divers",
		SousCategorie = {
			"Aucune",
			"Camelote",
			"Conteneur",
		},
	},
	{
		Nom = "Richesse",
		SousCategorie = {
			"Aucune",
			"Or",
			"Argent",
			"Bronze",
			"Pierre Rare",
			"Monnaie",
		},
	},
	{
		Nom = "Documents",
		SousCategorie = {
			"Aucune",
			"Lettre",
			"Missive",
			"Recette",
			"Contrat",
			"Facture",
			"Invitation",
			"Message Codé",
		},
	},
};