﻿function FicheNPCOpen(Panel,Arg0)

	if UnitName("target") ~= Arg0 then
		CloseAll();
	end

	FicheJoueurPanelNPC:Show();
	FicheNPCNomComplet:SetText(Arg0);
	FicheJoueurFond:SetTexture("Interface\\Stationery\\StationeryTest1.blp");
	FicheJoueurFondDroite:SetTexture("Interface\\Stationery\\StationeryTest2.blp");
	FicheNPCModel:SetUnit("target");

	FicheJoueurPanelNPCListe:Hide();
	FicheJoueurPanelNPCCommerce:Hide();
	NpcListeActionCommerce:Disable();
	NpcListeActionCommerceIcon:SetAlpha(0.5);
	NpcListeActionCommerceTexte:SetText(setTRPColorToString("{555555}Faire du commerce ..."));
	-- Pour la 1.2
	NpcListeActionRixe:Hide();
	------------------
	NpcListeActionRixe:Disable();
	NpcListeActionRixeIcon:SetAlpha(0.5);
	NpcListeActionRixeTexte:SetText(setTRPColorToString("{555555}Rixe de bar ..."));
	
	if not TRP_Module_Npcs[Royaume][Joueur][Arg0] then
		InitVariableNpc(Arg0);
	end
	
	calculerListeNpcActions();
	
	if Panel == nil or Panel == "ListeInteraction" then
		FicheJoueurPanelTitle:SetText(Arg0);
		animationPlayedNpc = 67;
		seqtimeNpc = 0;
		FicheJoueurPanelNPCListe:Show();
		FicheNPCNomInteraction:SetText("Interactions");
		if TRP_NPCS_VENDEURS[Arg0] then
			NpcListeActionCommerce:Enable();
			NpcListeActionCommerceIcon:SetAlpha(1);
			NpcListeActionCommerceTexte:SetText(setTRPColorToString("{ccffcc}Faire du commerce ..."));
		end
		--if TRP_NPCS_RIXE[Arg0] then
			NpcListeActionRixe:Enable();
			NpcListeActionRixeIcon:SetAlpha(1);
			NpcListeActionRixeTexte:SetText(setTRPColorToString("{ccffcc}Rixe de bar ..."));
		--end
	elseif Panel == "InteractionCommerce" then
		InitCommerce(Arg0);
	elseif Panel == "" then
		
	end
end

function modifyReputation(reput,nom)
	TRP_Module_Npcs[Royaume][Joueur][nom]["Reputation"] = TRP_Module_Npcs[Royaume][Joueur][nom]["Reputation"] + reput;
	if TRP_Module_Npcs[Royaume][Joueur][nom]["Reputation"] > 1000 then
		TRP_Module_Npcs[Royaume][Joueur][nom]["Reputation"] = 1000;
	end
	if TRP_Module_Npcs[Royaume][Joueur][nom]["Reputation"] < 1 then
		TRP_Module_Npcs[Royaume][Joueur][nom]["Reputation"] = 1;
	end
	if reput > 0 then
		Npc_Reputation_Texte_Plus:SetText("|cff00ff00+"..reput);
		Npc_Reputation_Texte_Plus:SetAlpha(1);
	elseif reput < 0 then
		Npc_Reputation_Texte_Moins:SetText("|cffff0000"..reput);
		Npc_Reputation_Texte_Moins:SetAlpha(1);
	end
end

function Reputation_OnUpdate(elapsed)
	if Npc_Reputation_Texte_Plus:GetAlpha() > 0 then
		local newValue = Npc_Reputation_Texte_Plus:GetAlpha()-(elapsed/2);
		if newValue < 0.01 then
			newValue = 0;
		end
		Npc_Reputation_Texte_Plus:SetPoint("LEFT", 100, (-292)-(newValue*20));
		Npc_Reputation_Texte_Plus:SetAlpha(newValue);
	end
	if Npc_Reputation_Texte_Moins:GetAlpha() > 0 then
		local newValue = Npc_Reputation_Texte_Moins:GetAlpha()-(elapsed/2);
		if newValue < 0.01 then
			newValue = 0;
		end
		Npc_Reputation_Texte_Moins:SetPoint("RIGHT", 0, (-292)-(newValue*20));
		Npc_Reputation_Texte_Moins:SetAlpha(newValue);
	end
	local rouge = (1/1000)*(1000-TRP_Module_Npcs[Royaume][Joueur][FicheNPCNomComplet:GetText()]["Reputation"]);
	local vert = (1/1000)*TRP_Module_Npcs[Royaume][Joueur][FicheNPCNomComplet:GetText()]["Reputation"];
	Npc_Emotion_Barre:SetTexture(rouge,vert,0);
	Npc_Emotion_Barre:SetWidth((74/1000)*TRP_Module_Npcs[Royaume][Joueur][FicheNPCNomComplet:GetText()]["Reputation"]);
	if TRP_Module_Npcs[Royaume][Joueur][FicheNPCNomComplet:GetText()]["Reputation"] < 10 then
		NpcReputationBoutonIcon:SetTexture("Interface\\ICONS\\Ability_Creature_Cursed_02.blp");
	elseif TRP_Module_Npcs[Royaume][Joueur][FicheNPCNomComplet:GetText()]["Reputation"] < 200 then
		NpcReputationBoutonIcon:SetTexture("Interface\\ICONS\\Ability_Warlock_ImprovedDemonicTactics.blp");
	elseif TRP_Module_Npcs[Royaume][Joueur][FicheNPCNomComplet:GetText()]["Reputation"] < 400 then
		NpcReputationBoutonIcon:SetTexture("Interface\\ICONS\\Ability_DualWield.blp");
	elseif TRP_Module_Npcs[Royaume][Joueur][FicheNPCNomComplet:GetText()]["Reputation"] < 600 then
		NpcReputationBoutonIcon:SetTexture("Interface\\ICONS\\Achievement_Reputation_01.blp");
	elseif TRP_Module_Npcs[Royaume][Joueur][FicheNPCNomComplet:GetText()]["Reputation"] < 800 then
		NpcReputationBoutonIcon:SetTexture("Interface\\ICONS\\Achievement_Reputation_05.blp");
	elseif TRP_Module_Npcs[Royaume][Joueur][FicheNPCNomComplet:GetText()]["Reputation"] < 1000 then
		NpcReputationBoutonIcon:SetTexture("Interface\\ICONS\\Achievement_Reputation_06.blp");
	else
		NpcReputationBoutonIcon:SetTexture("Interface\\ICONS\\INV_ValentinesCandy.blp");
	end
end

function Npc_Relation_Tooltip(but)
	GameTooltip:SetOwner(but, "ANCHOR_TOPLEFT");
	if TRP_Module_Npcs[Royaume][Joueur][FicheNPCNomComplet:GetText()]["Reputation"] < 10 then
		GameTooltip:AddLine("Désire votre mort");
	elseif TRP_Module_Npcs[Royaume][Joueur][FicheNPCNomComplet:GetText()]["Reputation"] < 200 then
		GameTooltip:AddLine("Haï");
	elseif TRP_Module_Npcs[Royaume][Joueur][FicheNPCNomComplet:GetText()]["Reputation"] < 400 then
		GameTooltip:AddLine("Inamical");
	elseif TRP_Module_Npcs[Royaume][Joueur][FicheNPCNomComplet:GetText()]["Reputation"] < 600 then
		GameTooltip:AddLine("Neutre");
	elseif TRP_Module_Npcs[Royaume][Joueur][FicheNPCNomComplet:GetText()]["Reputation"] < 800 then
		GameTooltip:AddLine("Amical");
	elseif TRP_Module_Npcs[Royaume][Joueur][FicheNPCNomComplet:GetText()]["Reputation"] < 1000 then
		GameTooltip:AddLine("Très Amical");
	else
		GameTooltip:AddLine("Extrêmement Amical");
	end
	GameTooltip:Show();
end

function Emotion_OnUpdate(elapsed)
	local nom = FicheNPCNomComplet:GetText();
	local emotion = TRP_Module_Npcs[Royaume][Joueur][nom]["Emotion"];
	local emotionTime = TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionDuration"];
	if Npc_Emotion_Change:GetAlpha() > 0 then
		local newValue = Npc_Emotion_Change:GetAlpha()-(elapsed/2);
		if newValue < 0.01 then
			newValue = 0;
		end
		Npc_Emotion_Change:SetPoint("CENTER", 0, 15 + (1-newValue)*20);
		Npc_Emotion_Change:SetAlpha(newValue);
	end
	NpcEmotionBoutonIcon:SetTexture(PNJ_EMOTION_TAB[emotion].Icone);
	
	if TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionTimeStamp"] then
		local minute = floor(time()/60) - TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionTimeStamp"];
		if minute >= emotionTime then
			setEmotion(nom,1);
		end
	end
end

function setEmotion(nom,emotion,force)
	if TRP_Module_Npcs[Royaume][Joueur][nom] then
		if emotion == 1 then
			TRP_Module_Npcs[Royaume][Joueur][nom]["Emotion"] = 1;
			TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionDuration"] = 0;
			TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionTimeStamp"] = nil;
			SetOverlayText(Npc_Emotion_Change,setTRPColorToString("{w}< "..PNJ_EMOTION_TAB[TRP_Module_Npcs[Royaume][Joueur][nom]["Emotion"]].Nom.." {w}>"));
		elseif TRP_Module_Npcs[Royaume][Joueur][nom]["Emotion"] == emotion then
			TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionDuration"] = TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionDuration"] + force;
			SetOverlayText(Npc_Emotion_Change,setTRPColorToString(PNJ_EMOTION_TAB[TRP_Module_Npcs[Royaume][Joueur][nom]["Emotion"]].Nom.." {v}++"));
		else
			if TRP_Module_Npcs[Royaume][Joueur][nom]["Emotion"] == 1 then
				TRP_Module_Npcs[Royaume][Joueur][nom]["Emotion"] = emotion;
				TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionDuration"] = force;
				TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionTimeStamp"] = floor(time()/60); -- En minutes
				SetOverlayText(Npc_Emotion_Change,setTRPColorToString("{w}< "..PNJ_EMOTION_TAB[TRP_Module_Npcs[Royaume][Joueur][nom]["Emotion"]].Nom.." {w}>"));
			elseif TRP_Module_Npcs[Royaume][Joueur][nom]["Emotion"] == 2 or TRP_Module_Npcs[Royaume][Joueur][nom]["Emotion"] == 4 then
				local saved = TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionDuration"];
				TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionDuration"] = TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionDuration"] - force;
				if TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionDuration"] < 0 then
					TRP_Module_Npcs[Royaume][Joueur][nom]["Emotion"] = emotion;
					TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionDuration"] = force - saved;
					TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionTimeStamp"] = floor(time()/60); -- En minutes
					SetOverlayText(Npc_Emotion_Change,setTRPColorToString("{w}< "..PNJ_EMOTION_TAB[TRP_Module_Npcs[Royaume][Joueur][nom]["Emotion"]].Nom.." {w}>"));
				else
					SetOverlayText(Npc_Emotion_Change,setTRPColorToString(PNJ_EMOTION_TAB[TRP_Module_Npcs[Royaume][Joueur][nom]["Emotion"]].Nom.." {r}--"));
				end
			else
				if TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionDuration"] < force then
					TRP_Module_Npcs[Royaume][Joueur][nom]["Emotion"] = emotion;
					TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionDuration"] = force - saved;
					TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionTimeStamp"] = floor(time()/60); -- En minutes
					SetOverlayText(Npc_Emotion_Change,setTRPColorToString("{w}< "..PNJ_EMOTION_TAB[TRP_Module_Npcs[Royaume][Joueur][nom]["Emotion"]].Nom.." {w}>"));
				end
			end
		end
	end
end

function caca(lol)
	setEmotion("Lisbeth Schneider",lol,1);
end

function Npc_Emotion_Tooltip(but)
	local nom = FicheNPCNomComplet:GetText();
	local emotion = TRP_Module_Npcs[Royaume][Joueur][nom]["Emotion"];
	GameTooltip:SetOwner(but, "ANCHOR_TOPLEFT");
	GameTooltip:AddLine(setTRPColorToString("{w}Emotion : "..PNJ_EMOTION_TAB[emotion].Nom));
	GameTooltip:AddLine(" ");
	decouperForTooltip("\""..PNJ_EMOTION_TAB[emotion].Descri.."\"",35,1,0.75,0);
	if TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionDuration"] > 0 then
		local intensite;
		local temps = TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionDuration"] - (floor(time()/60) - TRP_Module_Npcs[Royaume][Joueur][nom]["EmotionTimeStamp"]);
		debugMess("Temps restant : "..temps)
		if temps < 10 then
			intensite = "Infime (durée : Moins de 10 minutes)";
		elseif temps < 30 then
			intensite = "Très faible (durée : Au moins 10 minutes)";
		elseif temps < 60 then
			intensite = "Faible (durée : Au moins 30 minutes)";
		elseif temps < 240 then
			intensite = "Moyenne (durée : Au moins 1 heure)";
		elseif temps < 480 then -- 8 h
			intensite = "Forte (durée : Au moins 4 heures)";
		elseif temps < 1440 then -- 24h
			intensite = "Très Forte (durée : Au moins 12 heures)";
		elseif temps < 4320 then -- 3 jours
			intensite = "Énorme (durée : Au moins 2 jours)";
		else -- +
			intensite = "Incroyablement Forte (durée : Plus de 3 jours)";
		end
		GameTooltip:AddLine(" ");
		GameTooltip:AddLine(setTRPColorToString("{w}Intensité de l'émotion :"));
		GameTooltip:AddLine(setTRPColorToString("{o}"..intensite));
	end
	GameTooltip:Show();
end

function InitVariableNpc(Arg0)
	if TRP_Module_Npcs[Royaume][Joueur][Arg0] then
		wipe(TRP_Module_Npcs[Royaume][Joueur][Arg0]);
	else
		TRP_Module_Npcs[Royaume][Joueur][Arg0] 	= {};
	end
	TRP_Module_Npcs[Royaume][Joueur][Arg0]["Reputation"] = 500;
	TRP_Module_Npcs[Royaume][Joueur][Arg0]["Emotion"] = 1;
	TRP_Module_Npcs[Royaume][Joueur][Arg0]["EmotionDuration"] = 0; -- En minute
	TRP_Module_Npcs[Royaume][Joueur][Arg0]["LastInteraction"] = time();
	TRP_Module_Npcs[Royaume][Joueur][Arg0]["ActionTimeStamp"] = {};
end

function FicheNPCModel_OnUpdate(elapsed,sequence)
	seqtimeNpc = seqtimeNpc + (elapsed * 1000);
	FicheNPCModel:SetSequenceTime(sequence, seqtimeNpc);
end

function SetTargetNPCPortraitButton()
	local cible = UnitName("target");

	if not UnitIsPlayer("target") then
		if TRP_NPCS[cible] then -- Npc avec interactions
			TargetNPC_Vendeurs_PortraitButton:SetNormalTexture("Interface\\ICONS\\Achievement_Reputation_06.blp");
			TargetNPC_Vendeurs_PortraitButton:SetNormalTexture("Interface\\ICONS\\Achievement_Reputation_06.blp");
		else
			return;
		end
	else
		return;
	end
	
	TargetNPC_Vendeurs_PortraitButton.nom = cible;
	TargetNPC_Vendeurs_PortraitButton.trpaction = "Interactions avec "..TargetNPC_Vendeurs_PortraitButton.nom;
	TargetNPC_Vendeurs_PortraitButton:Show();
	anchorNpcIcon();
end

function anchorNpcIcon()
	if	XPerl_Target ~= nil then
		TargetNPC_Vendeurs_PortraitButton:SetPoint("CENTER", "XPerl_Target", "CENTER", 64, -45);
	elseif Perl_Target_Frame ~= nil then
		TargetNPC_Vendeurs_PortraitButton:SetPoint("CENTER", "Perl_Target_Frame", "CENTER", -115, -25);
	else
		TargetNPC_Vendeurs_PortraitButton:SetPoint("CENTER", "TargetFrame", "CENTER", -135, 10);
	end
end

function InitCommerce(Nom)
	local transactionMax = TRP_NPCS_VENDEURS[Nom]["TransactionMax"];
	
	FicheJoueurPanelNPCCommerce:Show();
	
	calculerListeNpcVendre();
	calculerListeNpcAcheter();
	FicheNPCNomInteraction:SetText("Commercer");
	TRPListeNPCVendre:Hide();
	TRPListeNPCAcheter:Show();
	NpcAcheterValeurSlider:SetValue(100+calculPourcentRelation(Nom));
	NpcVendreValeurSlider:SetValue(50-calculPourcentRelation(Nom));
	TRPListeNPCVendreOr:SetText(transactionMax.." |TInterface\\Icons\\INV_Misc_Coin_01:16|t");
	NpcCommerceScrollMessage:Clear();
	NpcVendeurDire(Nom,TRP_NPCS_VENDEURS[Nom]["PhrasesAcceuil"][math.random(#TRP_NPCS_VENDEURS[Nom]["PhrasesAcceuil"])],"dire",60);
end

function calculPourcentRelation(Nom)
	local reputation = TRP_Module_Npcs[Royaume][Joueur][Nom]["Reputation"];
	local modifReputation,modifFinale;
	
	if reputation >= 500 then
		local diff = reputation - 500;
		modifReputation = -((diff/300)*25);
	else
		local diff = 500-reputation;
		modifReputation = (diff/300)*50;
	end
	
	modifFinale = modifReputation;

	return modifFinale;
end

function decouperParoleForTooltip(text,taille,Rouge,Vert,Bleu,bColor)
	local ok = true;
	local morceaux = text;
	local j;

	while ok do
		local passageLigne = string.find(morceaux,"\n",1,taille);
		local indice = string.find(morceaux," ",taille);
		
		if passageLigne ~= nil then -- On a trouvé un passage à la ligne
			if not bColor then
				TRPGameTooltip:AddLine(string.sub(morceaux,1,passageLigne-1), Rouge, Vert, Bleu);
			else
				TRPGameTooltip:AddLine(setTRPColorToString(string.sub(morceaux,1,passageLigne-1)), Rouge, Vert, Bleu);
			end
			morceaux = string.sub(morceaux,passageLigne+1);
		elseif indice ~= nil then -- Fin de ligne
			if not bColor then
				TRPGameTooltip:AddLine(string.sub(morceaux,1,indice), Rouge, Vert, Bleu);
			else
				TRPGameTooltip:AddLine(setTRPColorToString(string.sub(morceaux,1,indice)), Rouge, Vert, Bleu);
			end
			morceaux = string.sub(morceaux,indice+1);
		else -- Fin de texte
			ok = false;
			if not bColor then
				TRPGameTooltip:AddLine(morceaux, Rouge, Vert, Bleu);
			else
				TRPGameTooltip:AddLine(setTRPColorToString(morceaux), Rouge, Vert, Bleu);
			end
		end
	end
	for j=1,TRPGameTooltip:NumLines() do
		getglobal("TRPGameTooltipTextLeft" .. j):SetFont("Fonts\\ARIALN.TTF",14);
		getglobal("TRPGameTooltipTextLeft" .. j):SetJustifyH("CENTER");
	end
	TRPGameTooltip.trpTime = time();
	TRPGameTooltip.trpTimeOver = TRPGameTooltip:NumLines();
	TRPGameTooltip.trpEtat = 1;
	TRPGameTooltip:Show();
end

function NpcVendeurDire(nom,texte,typeParole,animation)
	local chatType;
	if typeParole then
		if  typeParole == "dire" then
			chatType = ChatTypeInfo["MONSTER_SAY"];
			NpcCommerceScrollMessage:AddMessage(setTRPColorToString("["..nom.."] dit : "..texte),chatType.r,chatType.g,chatType.b,chatType.id);
		else
			return;
		end
		TRPGameTooltip:SetOwner(FicheNPCModel, "ANCHOR_RIGHT",-140,-40);
		decouperParoleForTooltip(texte,35, chatType.r,chatType.g,chatType.b);
		--TRPGameTooltip:FadeOut();
	else
		NpcCommerceScrollMessage:AddMessage(setTRPColorToString("< "..texte.." |r>"),1,1,1);
	end
	if animation then
		animationPlayedNpc = animation;
		seqtimeNpc = 0;
	end
end


function Reinit_NpcVendreListe()
	for k=1,16,1 do --Initialisation
		getglobal("NpcVendreBouton"..k).Slot = nil;
		getglobal("NpcVendreBouton"..k).ID = nil;
		getglobal("NpcVendreBouton"..k.."Icon"):SetTexture("Interface\\ICONS\\INV_Misc_GroupLooking.blp");
		getglobal("NpcVendreBouton"..k.."Qte"):SetText("");
		getglobal("NpcVendreBouton"..k):SetButtonState("NORMAL");
		getglobal("NpcVendreBouton"..k):Hide();
	end
end

function Reinit_NpcAcheterListe()
	for k=1,16,1 do --Initialisation
		getglobal("NpcAcheterBouton"..k).Slot = nil;
		getglobal("NpcAcheterBouton"..k).ID = nil;
		getglobal("NpcAcheterBouton"..k.."Icon"):SetTexture("Interface\\ICONS\\INV_Misc_GroupLooking.blp");
		getglobal("NpcAcheterBouton"..k.."Qte"):SetText("");
		getglobal("NpcAcheterBouton"..k):SetButtonState("NORMAL");
		getglobal("NpcAcheterBouton"..k):Hide();
	end
end

function Reinit_NpcActionsListe()
	for k=1,9,1 do --Initialisation
		getglobal("Npc_Liste_Actions_"..k).ID = nil;
		getglobal("Npc_Liste_Actions_"..k.."Icon"):SetTexture("Interface\\ICONS\\INV_Misc_GroupLooking.blp");
		getglobal("Npc_Liste_Actions_"..k):SetButtonState("NORMAL");
		getglobal("Npc_Liste_Actions_"..k):Hide();
		getglobal("Npc_Liste_Actions_"..k):Disable();
	end
end

function calculerListeNpcActions()
	local j = 0;

	wipe(NpcActionsTab);
	
	table.foreach(TRP_NPCS_ACTIONS,
	function(Action)
		NpcActionsTab[j+1] = {};
		NpcActionsTab[j+1].ID = Action;
		NpcActionsTab[j+1].bEnable = true;
		j = j+1;
	end);
	Npc_Liste_Actions_Frame.Num = 0;
	ChargerSliderListeNpcActions(Npc_Liste_Actions_Frame.Num);
end

function ChargerSliderListeNpcActions(num)
	Reinit_NpcActionsListe();
	Npc_Liste_Actions_Suiv:Show();
	Npc_Liste_Actions_Prev:Show();
	if NpcActionsTab ~= nil then
		for k=1,9,1 do 
			local i = num*9 + k;
			if NpcActionsTab[i] then
				local nom = FicheNPCNomComplet:GetText();
				local ID = NpcActionsTab[i].ID;
				local bEnabled = NpcActionsTab[i].bEnable;
				local bouton = getglobal("Npc_Liste_Actions_"..k);
				local boutonIcon = getglobal("Npc_Liste_Actions_"..k.."Icon");
				
				boutonIcon:SetTexture(TRP_NPCS_ACTIONS[ID].Icone);
				if bEnabled then
					boutonIcon:SetDesaturated(nil);
					bouton:Enable();
				else
					boutonIcon:SetDesaturated(1);
				end
				bouton:Show();
				bouton:SetScript("OnEnter", function() 
					SetActionTooltip(TRP_NPCS_ACTIONS[ID],bouton);
				end);
				bouton:SetScript("OnLeave", function() 
					GameTooltip:Hide();
				end);
				bouton:SetScript("OnClick", function(self,button) 
					executeAction(NpcActionsTab[i].ID);
				end);
				
				if TRP_NPCS_ACTIONS[ID].Nom == "Saluer" then
					Npc_Liste_Actions_Prev:Hide();
				end
				if TRP_NPCS_ACTIONS[ID].Nom == "Saluer" then
					Npc_Liste_Actions_Suiv:Hide();
				end
			end
		end
	end
end

function executeAction(action)
	actionTab = TRP_NPCS_ACTIONS[action]
	local nom = FicheNPCNomComplet:GetText();
	local chance = actionTab.Chance;
	local already;
	
	if TRP_Module_Npcs[Royaume][Joueur][nom]["ActionTimeStamp"][action] and TRP_Module_Npcs[Royaume][Joueur][nom]["ActionTimeStamp"][action] == date("%y%m%d") then
		already = true;
	end
	
	if math.random(100) < chance then -- Gagné
		if not already and actionTab.modifyEmotion and actionTab.modifyEmotionOnWin then
			setEmotion(nom,actionTab.modifyEmotionOnWin,actionTab.modifyTimeOnWin);
		end
	else	--raté
		if not already and actionTab.modifyEmotion and actionTab.modifyEmotionOnLoose then
			setEmotion(nom,actionTab.modifyEmotionOnLoose,actionTab.modifyTimeOnLoose);
		end
	end
	if actionTab.modifyMorale then
		--modifyMorale(actionTab.modifyMorale);
	end
	if not already then
		if actionTab.modifyReputation then
			modifyReputation(actionTab.modifyReputation,nom);
		end
	end
	
	if actionTab.workPerDay then
		TRP_Module_Npcs[Royaume][Joueur][nom]["ActionTimeStamp"][action] = date("%y%m%d");
	end
end

function SetActionTooltip(action,bouton)
	GameTooltip:SetOwner(bouton, "ANCHOR_TOPLEFT");
	GameTooltip:AddLine(setTRPColorToString(action.modifyColor..action.Nom));
	decouperForTooltip("\""..action.descri.."\"",30,1,0.75,0);
	GameTooltip:AddLine(" ");
	GameTooltip:AddLine(setTRPColorToString("Chance de réussite : {o}"..action.Chance.."%"),1,1,1);
	if action.modifyEmotion then
		GameTooltip:AddLine(" ");
		local OnWin = PNJ_EMOTION_TAB[action.modifyEmotionOnWin].Nom.." "..action.modifyPuissanceOnWin;
			  OnWin = "|T"..PNJ_EMOTION_TAB[action.modifyEmotionOnWin].Icone..":35:35|t   "..OnWin;
		local OnLoose;
		if action.modifyEmotionOnLoose then
			OnLoose = PNJ_EMOTION_TAB[action.modifyEmotionOnLoose].Nom.." "..action.modifyPuissanceOnLoose;
			OnLoose = "|T"..PNJ_EMOTION_TAB[action.modifyEmotionOnLoose].Icone..":35:35|t   "..OnLoose;
		end
		
		GameTooltip:AddLine(setTRPColorToString("Influence sur l'émotion :"),1,1,1);
		if OnLoose then
			GameTooltip:AddLine(setTRPColorToString("   {j}Si réussite :"),1,1,1);
			GameTooltip:AddLine(setTRPColorToString("      "..OnWin),1,1,1);
			GameTooltip:AddLine(setTRPColorToString("   {o}Si échec :"),1,1,1);
			GameTooltip:AddLine(setTRPColorToString("      "..OnLoose),1,1,1);
		else
			GameTooltip:AddLine(setTRPColorToString("   "..OnWin),1,1,1);
		end
	end
	if action.modifyReputation then
		GameTooltip:AddLine(" ");
		GameTooltip:AddLine(setTRPColorToString("Influence sur la réputation :"),1,1,1);
		if action.modifyReputation > 0 then
			GameTooltip:AddLine(setTRPColorToString(action.modifyReputation.." point(s)"),0,1,0);
		else
			GameTooltip:AddLine(setTRPColorToString(action.modifyReputation.." point(s)"),1,0,0);
		end
	end
	if action.modifyMorale then
		GameTooltip:AddLine(" ");
		if action.modifyMorale > 0 then
			GameTooltip:AddLine(setTRPColorToString("Influence {v}positive{w} sur votre Morale."),1,1,1);
		else
			GameTooltip:AddLine(setTRPColorToString("Influence {r}négative{w} sur votre Morale."),1,1,1);
		end
	end
	local nom = FicheNPCNomComplet:GetText();
	if action.workPerDay and TRP_Module_Npcs[Royaume][Joueur][nom]["ActionTimeStamp"][action.Nom] and TRP_Module_Npcs[Royaume][Joueur][nom]["ActionTimeStamp"][action.Nom] == date("%y%m%d") then
		GameTooltip:AddLine(" ");
		GameTooltip:AddLine(setTRPColorToString("< Vous avez déjà effectuer cette action aujourd'hui,"),1,0.75,0);
		GameTooltip:AddLine(setTRPColorToString("la refaire n'aura pas d'incidence sur les statistiques. >"),1,0.75,0);
	end
	GameTooltip:Show();
end

function calculerListeNpcVendre()
	local j = 0;
	local nom = FicheNPCNomComplet:GetText();
	
	NpcVendreBoutonSlider:Hide();
	NpcVendreBoutonSlider:SetValue(0);
	wipe(NpcVendreTab);
	TRPListeNPCVendreRien:Hide();
	
	table.foreach(TRP_Module_Inventaire[Royaume][Joueur],
	function(Slot)
		if Slot ~= "Or" and Slot ~= "Sacs" and Slot ~= "Cooldown" then
			if string.len(TRP_Module_Inventaire[Royaume][Joueur][Slot]["ID"]) ~= 16 and tonumber(TRP_Module_Inventaire[Royaume][Joueur][Slot]["Sac"]) == -1 then
				NpcVendreTab[j+1] = Slot;
				j = j+1;
			end
		end
	end);
	
	if j > 16 then
		local total = floor((j-1)/16);
		NpcVendreBoutonSlider:Show();
		NpcVendreBoutonSlider:SetMinMaxValues(0,total);
	elseif j == 0 then
		--NpcVendeurDire(nom,"Désolé mais vous n'avez rien sur vous qui m'intéresse.","dire",186);
		TRPListeNPCVendreRien:SetText("Vous n'avez rien dans votre sac à dos qui intéresse ce commerçant.");
		TRPListeNPCVendreRien:Show();
	end
	
	ChargerSliderListeNpcVendre(0);
end

function calculerListeNpcAcheter()
	local j = 0;
	local nom = FicheNPCNomComplet:GetText();
	
	NpcAcheterBoutonSlider:Hide();
	NpcAcheterBoutonSlider:SetValue(0);
	wipe(NpcAcheterTab);
	--TRPListePersonnagesEmpty:Hide();
	
	table.foreach(TRP_NPCS_VENDEURS[nom]["Inventaire"],
	function(Slot)
		if TRP_Objects[TRP_NPCS_VENDEURS[nom]["Inventaire"][Slot]["ID"]] then
			NpcAcheterTab[j+1] = Slot;
			j = j+1;
		end
	end);
	
	table.sort(NpcAcheterTab);
	
	if j > 16 then
		local total = floor((j-1)/16);
		NpcAcheterBoutonSlider:Show();
		NpcAcheterBoutonSlider:SetMinMaxValues(0,total);
	elseif j == 0 then
		--TRPListePersonnagesEmpty:Show();
	end
	
	ChargerSliderListeNpcAcheter(0);
end

function ChargerSliderListeNpcVendre(num)
	Reinit_NpcVendreListe();
	if NpcVendreTab ~= nil then
		for k=1,16,1 do 
			local i = num*16 + k;
			if NpcVendreTab[i] then
				local nom = FicheNPCNomComplet:GetText();
				local vendeurID = TRP_NPCS_VENDEURS[nom];
				local ID = TRP_Module_Inventaire[Royaume][Joueur][NpcVendreTab[i]]["ID"];
				local objetID;
				local bouton = getglobal("NpcVendreBouton"..k);
				local boutonIcon = getglobal("NpcVendreBouton"..k.."Icon");
				local boutonQte = getglobal("NpcVendreBouton"..k.."Qte");
				if string.len(ID) == 16 then
					objetID = TRP_Module_ObjetsPerso[ID];
				else
					objetID = TRP_Objects[ID];
				end
				bouton.Slot = NpcVendreTab[i];
				bouton.ID = ID;
				bouton:RegisterForClicks("RightButtonUp");
				bouton.Charges = TRP_Module_Inventaire[Royaume][Joueur][NpcVendreTab[i]]["Charges"];
				if TRP_Module_Inventaire[Royaume][Joueur][NpcVendreTab[i]]["Qte"] > 1 then
					boutonQte:SetText(TRP_Module_Inventaire[Royaume][Joueur][NpcVendreTab[i]]["Qte"]);
				end
				boutonIcon:SetTexture("Interface\\ICONS\\"..objetID["Icone"]..".blp");
				bouton:Show();
				bouton:SetScript("OnEnter", function() 
					SetObjetTooltip(TRP_Module_Inventaire[Royaume][Joueur][NpcVendreTab[i]],bouton,1,math.ceil((objetID["Valeur"]/100)*NpcVendreValeurSlider:GetValue()),vendeurID["TransactionMax"]);
				end);
				bouton:SetScript("OnLeave", function() 
					GameTooltip:Hide();
					TRP_Objet_3D_Apercu:Hide();
				end);
				bouton:SetScript("OnClick", function(self,button) 
					local prixUnitaire = math.ceil((objetID["Valeur"]/100)*NpcVendreValeurSlider:GetValue());
					if button == "RightButton" then
						if IsShiftKeyDown() then
							TRP_ShowStaticPopup("TRP_NPC_VENDRE_AMOUNT","Vendre {v}["..objetID["Nom"].."]","{w}Vendre combient d'unité(s) ? (Max "..TRP_Module_Inventaire[Royaume][Joueur][NpcVendreTab[i]]["Qte"]..")\n\nPrix unitaire : "..prixUnitaire.." pièce(s) d'or",NpcVendreTab[i],prixUnitaire,nom,ID,true,TRP_Module_Inventaire[Royaume][Joueur][NpcVendreTab[i]]["Qte"]);
						else
							VendreObjet(NpcVendreTab[i],1,prixUnitaire,nom,ID);
						end
					end
				end);
			end
		end
	end
end

function ChargerSliderListeNpcAcheter(num)
	Reinit_NpcAcheterListe();
	if NpcAcheterTab ~= nil then
		for k=1,16,1 do 
			local i = num*16 + k;
			if NpcAcheterTab[i] then
				local nom = FicheNPCNomComplet:GetText();
				local ID = TRP_NPCS_VENDEURS[nom]["Inventaire"][NpcAcheterTab[i]]["ID"];
				local objet = TRP_Objects[ID];
				local bouton = getglobal("NpcAcheterBouton"..k);
				local boutonIcon = getglobal("NpcAcheterBouton"..k.."Icon");
				local boutonQte = getglobal("NpcAcheterBouton"..k.."Qte");
				local Qte = TRP_NPCS_VENDEURS[nom]["Inventaire"][NpcAcheterTab[i]]["Qte"];
				
				bouton.Slot = NpcVendreTab[i];
				bouton.ID = ID;
				bouton:RegisterForClicks("RightButtonUp");
				if Qte and Qte > 1 then
					boutonQte:SetText(Qte);
				end
				boutonIcon:SetTexture("Interface\\ICONS\\"..objet["Icone"]..".blp");
				bouton:Show();
				bouton:SetScript("OnEnter", function() 
					SetObjetTooltip(TRP_NPCS_VENDEURS[nom]["Inventaire"][NpcAcheterTab[i]],bouton,2,math.ceil((objet["Valeur"]/100)*NpcAcheterValeurSlider:GetValue()));
				end);
				bouton:SetScript("OnLeave", function() 
					GameTooltip:Hide();
					TRP_Objet_3D_Apercu:Hide();
				end);
				bouton:SetScript("OnClick", function(self,button) 
					local prixUnitaire = math.ceil((objet["Valeur"]/100)*NpcAcheterValeurSlider:GetValue());
					if button == "RightButton" then
						if IsShiftKeyDown() then
							TRP_ShowStaticPopup("TRP_NPC_ACHETER_AMOUNT","Acheter {v}["..objet["Nom"].."]","{w}Acheter combient d'unité(s) ?\n\nPrix unitaire : "..prixUnitaire.." pièce(s) d'or",ID,prixUnitaire,nom,nil,true);
						else
							AcheterObjet(ID,1,prixUnitaire,nom);
						end
					end
				end);
			end
		end
	end
end

function AcheterObjet(ID,Qte,prixUnitaire,Nom)
	local prixTotal = prixUnitaire*Qte;
	local rapportPrix;
	local i;
	local Objet = TRP_Objects[ID];
	local echec;
	
	if Objet["Valeur"] ~= 0 then
		rapportPrix = prixUnitaire/Objet["Valeur"];
	end

	local diff = ceil((Objet["Valeur"]/100)*(100 + calculPourcentRelation(Nom))) - prixUnitaire;
	diff = ((diff/100) * ceil((Objet["Valeur"]/100)*(100 + calculPourcentRelation(Nom))))*100;
	
	if diff > 0 then
		if random(25) < diff then
			echec = true;
		end
	end
	
	if echec then
		NpcVendeurDire(Nom,"Cela vaut plus que ça !","dire",64);
		NpcVendeurDire(nil,"{r}Le vendeur refuse la transaction.");
		modifyReputation(-1,Nom);
		return;
	end
	
	if TRP_Module_Inventaire[Royaume][Joueur]["Or"]["SacADos"] < prixTotal then
		-- T'as pas assez de fric !
		NpcVendeurDire(nil,"{r}Vous n'avez pas assez d'argent pour cette transaction.");
	else
		local code = canReceiveObjet(ID,Qte);
		if code == 1 then
			GetObjets(ID,-1,Qte);
			NpcVendeurDire(nil,"{j}Vous achetez :\n   "..Qte.."x {v}\""..Objet["Nom"].."\"\n{j}pour "..prixTotal.." |4pièce:pièces; d'or");
			NpcVendeurDire(Nom,"Merci !","dire",60);
			if diff > 0 then
				modifyReputation(1,Nom);
			else
				modifyReputation(1,Nom);
			end
		elseif code == 2 then
			NpcVendeurDire(nil,"{r}Vous ne pouvez posséder plus d'unité de cet objet.");
		end
	end
	
end

function VendreObjet(Slot,Qte,prixUnitaire,Nom,ID)
	local rapportPrix;
	local i;
	local Objet = TRP_Objects[ID];
	local echec;
	
	if Objet["Valeur"] ~= 0 then
		rapportPrix = prixUnitaire/Objet["Valeur"];
	end
	
	if Qte > TRP_Module_Inventaire[Royaume][Joueur][Slot]["Qte"] then
		Qte = TRP_Module_Inventaire[Royaume][Joueur][Slot]["Qte"];
	end
	
	local prixTotal = prixUnitaire*Qte;
	
	local diff = ceil((Objet["Valeur"]/100)*(50 - calculPourcentRelation(Nom))) - prixUnitaire;
	diff = ((diff/100) * ceil((Objet["Valeur"]/100)*(50 - calculPourcentRelation(Nom))))*100;
	diff = - diff;
	
	if diff > 0 then
		if random(25) < diff then
			echec = true;
		end
	end
	
	if echec then
		NpcVendeurDire(Nom,"Cela vaut pas tant que ça !","dire",64);
		NpcVendeurDire(nil,"{r}Le vendeur refuse la transaction.");
		modifyReputation(-1,Nom);
		return;
	end
	
	if TRP_NPCS_VENDEURS[Nom]["TransactionMax"] < prixTotal then
		-- Transaction trop chère !
		NpcVendeurDire(nil,"{r}Je n'ai pas assez d'argent pour une telle transaction.");
	else
		proceedDeleteObject(Slot,Qte);
		NpcVendeurDire(nil,"{j}Vous vendez :\n   "..Qte.."x {v}\""..Objet["Nom"].."\"\n{j}pour "..prixTotal.." |4pièce:pièces; d'or");
		NpcVendeurDire(Nom,"Merci !","dire",60);
		modifyReputation(1,Nom);
		calculerListeNpcVendre();
	end
	
end
